////////////////////////////////////////////////////////////////////////
// pageelems.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.pageelems")

// <%pre>
#line 1 "pageelems.ecpp"

#include "../services.h"

#include <livefeatures.h>
#include <setup.h>
#include <timers.h>
#include <tools.h>
#include <epg_events.h>
#include <gen_version_suffix.h>
#include <tntfeatures.h>

using namespace vdrlive;

std::string toString(const std::vector<std::string> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const std::string &str:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(str);
  }
  return result;
}
  
std::string toString(const std::vector<int> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const int &i:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(std::to_string(i) );
  }
  return result;
}
  
std::string toString(const std::vector<cActor> &vec) {
  if (vec.size() == 0) return "";
  std::string result;
  for (const cActor &actor:vec) {
    if (!result.empty() ) result.append(", ");
    result.append(actor.name);
    if (!actor.role.empty() ) {
      result.append(" (");
      result.append(actor.role);
      result.append(")");
    }
  }
  return result;
}


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    class doc_type_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        doc_type_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class create_html_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        create_html_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class stylesheets_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        stylesheets_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class logo_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        logo_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hide_element_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hide_element_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class progressbar_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        progressbar_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_action_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_action_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class imdb_info_href_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        imdb_info_href_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class hls_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        hls_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_channel_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_channel_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class m3u_playlist_recording_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        m3u_playlist_recording_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class event_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        event_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class edit_timer_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        edit_timer_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class ajax_js_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        ajax_js_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class infobox_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        infobox_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tool_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tool_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class epg_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        epg_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class media_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        media_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    class about_tt_box_type : public tnt::EcppSubComponent
    {
        _component_& mainComp;
        _component_& main()  { return mainComp; }

      public:
        about_tt_box_type(_component_& m, const std::string& name)
          : EcppSubComponent(m, name),
            mainComp(m)
          { }
        unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
    };

    doc_type_type doc_type;
    create_html_js_type create_html_js;
    stylesheets_type stylesheets;
    logo_type logo;
    hide_element_type hide_element;
    progressbar_type progressbar;
    ajax_action_href_type ajax_action_href;
    imdb_info_href_type imdb_info_href;
    hls_channel_type hls_channel;
    m3u_playlist_channel_type m3u_playlist_channel;
    m3u_playlist_recording_type m3u_playlist_recording;
    event_timer_type event_timer;
    edit_timer_type edit_timer;
    ajax_js_type ajax_js;
    infobox_type infobox;
    epg_tool_box_type epg_tool_box;
    epg_tt_box_type epg_tt_box;
    media_type media;
    about_tt_box_type about_tt_box;
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("pageelems");

static const char* rawData = "\240\006\000\000\241\006\000\000\243\006\000\000\021\007\000\000\022\007\000\000\024\007"
  "\000\000\004\010\000\000\236\t\000\000\276\t\000\000\363\t\000\000\377\t\000\000\013\n\000\000R\n\000\000^\n\000\000j"
  "\n\000\000\243\n\000\000&\013\000\000\226\014\000\000\247\014\000\000\263\014\000\000\014\016\000\000\025\016\000\000"
  "\220\016\000\000\231\016\000\000\263\016\000\000\033\017\000\000$\017\000\000-\017\000\000I\017\000\000x\020\000\000"
  "\372\020\000\000\021\021\000\000\373\023\000\000\377\023\000\000`\026\000\000\344\026\000\000'\027\000\000\016\030"
  "\000\000I\031\000\000M\031\000\000\260\033\000\000\262\033\000\000\036\034\000\000\352\034\000\000\353\034\000\000"
  "\355\034\000\000\264\035\000\000\316\035\000\000\327\035\000\000\344\035\000\000\016\036\000\0005\036\000\0006\036"
  "\000\0008\036\000\000R\036\000\000S\036\000\000U\036\000\000a\036\000\000z\036\000\000~\036\000\000\177\036\000\000"
  "\215\036\000\000\236\036\000\000\237\036\000\000\241\036\000\000\244\036\000\000\250\036\000\000\252\036\000\000\275"
  "\036\000\000\304\036\000\000\306\036\000\000\307\036\000\000\322\036\000\000\331\036\000\000\346\036\000\000\347\036"
  "\000\000\351\036\000\000\023\037\000\000\025\037\000\0008\037\000\000:\037\000\000U\037\000\000^\037\000\000j\037\000"
  "\000k\037\000\000m\037\000\000\220\037\000\000\234\037\000\000\245\037\000\000\261\037\000\000\262\037\000\000\264"
  "\037\000\000\326\037\000\000\342\037\000\000\353\037\000\000\367\037\000\000\025 \000\000! \000\000* \000\0006 \000"
  "\0007 \000\0009 \000\000U \000\000a \000\000j \000\000r \000\000w \000\000x \000\000z \000\000| \000\000} \000\000"
  "\236 \000\000\252 \000\000\263 \000\000\273 \000\000\274 \000\000\276 \000\000\340 \000\000\354 \000\000\365 \000\000"
  "\375 \000\000\377 \000\000\001!\000\000B#\000\000U#\000\000\217#\000\000\231#\000\000\266#\000\000\300#\000\000\335#"
  "\000\000\275$\000\000\035%\000\000\036%\000\000 %\000\000\227%\000\000\320&\000\000\360&\000\000L'\000\000Q'\000\000V"
  "'\000\000['\000\000`'\000\000\225'\000\000\232'\000\000\302'\000\000\037(\000\000I(\000\000`(\000\000a(\000\000c(\000"
  "\000d(\000\000e(\000\000h(\000\000i(\000\000\222(\000\000\236(\000\000\247(\000\000\263(\000\000\264(\000\000\266("
  "\000\000\267(\000\000\271(\000\000\272(\000\000\377(\000\000\t)\000\000\n)\000\000G)\000\000K)\000\000O)\000\000a)"
  "\000\000})\000\000\177)\000\000\205)\000\000\231)\000\000\233)\000\000\243)\000\000\267)\000\000\275)\000\000\350)"
  "\000\000\364)\000\000\375)\000\000\020*\000\000$*\000\000&*\000\000.*\000\000B*\000\000D*\000\000L*\000\000`*\000\000"
  "c*\000\000f*\000\000g*\000\000o*\000\000p*\000\000r*\000\000\224*\000\000\321*\000\000\367*\000\000++\000\0000+\000"
  "\000>+\000\000v+\000\000z+\000\000\210+\000\000\277+\000\000\304+\000\000\322+\000\000\n,\000\000\017,\000\000\033,"
  "\000\0000,\000\0007,\000\000\241,\000\000\371,\000\000\014-\000\000\016-\000\000%-\000\000'-\000\000/-\000\000P-\000"
  "\000]-\000\000\201-\000\000\242-\000\000\252-\000\000\266-\000\000\267-\000\000\332-\000\000\341-\000\000\005.\000"
  "\000$.\000\000L.\000\000k.\000\000\213.\000\000\250.\000\000\326.\000\000\372.\000\000\022/\000\000\?/\000\000^/\000"
  "\000x/\000\000\250/\000\000\311/\000\000\343/\000\000\344/\000\000\0200\000\000\0210\000\00020\000\000\?0\000\000A0"
  "\000\000M0\000\000_0\000\000{0\000\000\2040\000\000\2130\000\000\2470\000\000\2500\000\000\2570\000\000\3150\000\000"
  "\3170\000\000\3200\000\000\3210\000\000\3660\000\000\3710\000\000\0001\000\000 1\000\000!1\000\000$1\000\000+1\000"
  "\000I1\000\000J1\000\000Q1\000\000q1\000\000r1\000\000y1\000\000z1\000\000\2441\000\000\2671\000\000\2751\000\000\335"
  "1\000\000\3621\000\000\0342\000\00002\000\000C2\000\000m2\000\000\2012\000\000\2242\000\000\2762\000\000\3222\000\000"
  "\3452\000\000\3642\000\000\0203\000\000\0303\000\000\0373\000\000;3\000\000B3\000\000e3\000\000n3\000\000u3\000\000"
  "\2333\000\000\2553\000\000\2703\000\000\3243\000\000\3273\000\000\3363\000\000\3723\000\000\0024\000\000\t4\000\000%4"
  "\000\000*4\000\00014\000\000M4\000\000N4\000\000Q4\000\000X4\000\000Y4\000\000\2424\000\000\2654\000\000\3064\000\000"
  "\3074\000\000\3454\000\000\3564\000\000\3654\000\000\0235\000\000\0335\000\000\"5\000\000#5\000\000A5\000\000B5\000"
  "\000I5\000\000g5\000\000p5\000\000w5\000\000x5\000\000\2265\000\000\2515\000\000\3235\000\000\3475\000\000\3725\000"
  "\000(6\000\000>6\000\000S6\000\000\2016\000\000\2276\000\000\2546\000\000\2676\000\000\2766\000\000\3126\000\000\3336"
  "\000\000\3436\000\000\3566\000\000\0217\000\000A7\000\000H7\000\000J7\000\000\1777\000\000\2257\000\000\2337\000\000"
  "\2557\000\000\2637\000\000\2747\000\000\3037\000\000\3177\000\000\3417\000\000\3427\000\000\3437\000\000\3537\000\000"
  "\3677\000\000\0038\000\00008\000\00018\000\00028\000\000H8\000\000t8\000\000\2318\000\000\2338\000\000\0249\000\000{9"
  "\000\000\2529\000\000\006:\000\000k:\000\000\004;\000\000d;\000\000\302;\000\000%<\000\000\231<\000\000\310<\000\000"
  "\355<\000\000\020=\000\0005=\000\000b=\000\000\300=\000\000\336=\000\000\342=\000\000\350=\000\000\352=\000\000\353="
  "\000\000\361=\000\000\363=\000\000\364=\000\000I>\000\000\261>\000\000\317>\000\000\323>\000\000\331>\000\000\333>"
  "\000\000\334>\000\000\342>\000\000\344>\000\000\345>\000\000:\?\000\000\233\?\000\000\271\?\000\000\275\?\000\000\303"
  "\?\000\000\305\?\000\000\306\?\000\000\314\?\000\000\316\?\000\000\317\?\000\000 @\000\000\134@\000\000WC\000\000\206"
  "C\000\000vD\000\000\n\n\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD"
  "/xhtml1-strict.dtd\">\n\n\n\n<script type=\"text/javascript\" src=\"js/live/createHtml.js\"></script>\n<script>\nfunc"
  "tion addErrorIcon(s, numErrors, durationDeviation, duration) {\n  if (numErrors <= -100) return\n  s.a += '<div class"
  "=\"recording_errors\"><img class=\"icon\" src=\"'\n  if (durationDeviation > 300 || numErrors  > 0) s.a += 'Recording"
  "Errors.png'\n  else if (durationDeviation > 60) s.a += 'NotCheckedForRecordingErrors.png'\n  else {\n    if (numError"
  "s == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'RecordingErrors.png'\n    if (numErrors  < 0)"
  " s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '\" width = \"16px\" title=\"'\n  if (numErrors == 0) s.a +"
  "= ''\n  if (numErrors  > 0) s.a += ' ' + String(numErrors)\n  if (numErrors  < 0) s.a += ''\n  s.a += ''\n  s.a += ''"
  "\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += ''\n  s.a += ''\n  s.a += ''\n  s.a += ': '"
  "\n  s.a += duration\n  s.a += ' '\n  s.a += ''\n  s.a += '\" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip) "
  "{\n  s.a += '<div class=\"recording_sd_hd\"><img class=\"icon\" src=\"'\n  s.a += hdsd\n  s.a += 'd.png\" width = \"2"
  "5px\" title=\"'\n  s.a += toolTip\n  s.a += '\" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length "
  "== 0) {\n    s.a += '<a href=\"http://www.imdb.com/find\?s=all&q='\n    s.a += name\n  } else {\n    s.a += '<a href="
  "\"https://www.imdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n   '\" target=\"_blank\"><img class=\"icon\" src=\""
  "imdb.png\" title=\"\"/></a>'\n}\n\n\nfunction addEvent(s, bottomrow_i, obj) {\n// first column, timer /red or green, "
  "...\n  let bottomrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bottomrow'\n  s.a += `<tr><td class=\"action leftcol "
  "${bottomrow}\">`\n  if (obj[1].length != 0) {\n    s.a += '<a href=\"edit_timer.html\?timerid=timer_'\n    s.a += obj"
  "[1]\n    s.a += '\"><img class=\"icon\" src=\"\" title=\"\" />'\n  } else {\n    s.a += '<a href=\"edit_timer.html\?e"
  "pgid=event_'\n    s.a += obj[0]\n    s.a += '\"><img class=\"icon\" src=\"\" title=\"\" />'\n  }\n  s.a += '</a>'\n  "
  "s.a += '<a href=\"searchresults.html\?searchplain='\n  s.a += obj[11]\n  s.a += '\"><img class=\"icon\" src=\"\" titl"
  "e=\"\"/></a>'\n  IMDBS(s, obj[2], obj[11])\n  s.a += '</td>'\n// second col, dependent on width: channel\n  if (obj[9"
  "] > 0) {\n    s.a += `<td class=\"td-hidden-xs ${bottomrow}\"><div class=\"hidden-xs withmargin\"><a href=\"schedule."
  "html\?channel=`\n    s.a += obj[9]\n    s.a += '\">'\n    s.a += obj[10]\n    s.a += '</a></div></td>'\n  }\n// third"
  " col: image\n    s.a += `<td class=\"enlarge-image ${bottomrow}\">`\n    addScraperImageTitle(s, obj[3], obj[4], obj["
  "5], obj[6], obj[7], obj[8], '');\n    s.a += '</td>'\n  s.a += `<td class=\"td-hidden-xs ${bottomrow}\"><div class=\""
  "hidden-xs withmargin\">`\n  s.a += obj[14]\n  s.a += '</div></td>'\n// col with times, channel, name, short text\n  s"
  ".a += `<td class=\"rightcol ${bottomrow}\"><div class=\"withmargin\">`\n// first line: link to channel, times, channe"
  "l\n  s.a += '<div class=\"margin-bottom display-xs\">'\n  if (obj[9] > 0) {\n    s.a += '<a href=\"schedule.html\?cha"
  "nnel='\n    s.a += obj[9]\n    s.a += '\">'\n  }\n  s.a += '<span class=\"normal-font\">'\n  s.a += obj[14]\n  if (ob"
  "j[9] > 0) {\n    s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '"
  "</div>'\n// sec&third line: Link to event, event title, short text\n  addEventRec(s, 'event_', obj[0], obj[11], '', o"
  "bj[12], obj[13], '', '')\n  s.a += '</div></td></tr>'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object"
  ".create(null)\n  s.a = \"\"\n  addEvent(s, bottomrow, data)\n  return s.a\n}\n\n// existing recording\nfunction exist"
  "ingRecordingSR(s, col_span1, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s"
  "_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder"
  ", duration) {\n  if (archiveDescr.length != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString"
  "()\n  s.a += ' class=\"leftcol '\n  s.a += bottomrow\n  s.a += '\">'\n  if (archiveDescr.length != 0) {\n    s.a += '"
  "</td><td class=\"action '\n    s.a += bottomrow\n    s.a += '\"> <img class=\"icon\" src=\"\" alt=\"on dvd\" title=\""
  " />'\n    s.a += archiveDescr\n    s.a += '/>'\n  } else {\n    s.a += '<br/><table><tr><td class=\"noborder\">'\n   "
  " addErrorIcon(s, errors, durationDeviation, duration)\n    s.a += '</td><td class=\"noborder\">'\n    addHdSdIcon(s, "
  "hd_sd, channel_name)\n    s.a += '</td></tr></table>'\n  }\n  s.a += '</td><td class=\"td-hidden-xs '\n  s.a += botto"
  "mrow\n  s.a += '\"><div class=\"hidden-xs recording_day\">'\n  s.a += day_time_duration\n  s.a += '</div></td><td cla"
  "ss=\"rightcol '\n  s.a += bottomrow\n  s.a += '\">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, f"
  "older, short_text, description, '', '')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomr"
  "ow, id, archiveDescr, imdb_id, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd"
  "_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration) {\n  const s = Object.cr"
  "eate(null)\n  s.a = \"\"\n  existingRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title"
  ", s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, descri"
  "ption, durationDeviation, folder, duration)\n  return s.a\n}\n\n\n</script>\n\n\n<link rel=\"stylesheet\" type=\"text"
  "/css\" href=\"css/styles.css\"/>\n<link rel=\"stylesheet\" type=\"text/css\" href=\"\"/>\n<link rel=\"stylesheet\" ty"
  "pe=\"text/css\" href=\"css/siteprefs.css\"/>\n<script type=\"text/javascript\" src=\"js/live/header.js\"></script>\n<"
  "script type=\"text/javascript\" src=\"js/live/epg_tt_box.js\"></script>\n\n\n\n<!-- start of fixed page header -->\n<"
  "div id=\"header\" style=\"width: 100%; background-color: inherit\">\n<div id=\"padding\" style=\"display: none\"></di"
  "v>\n<div id=\"content\">\n<!-- header content follows -->\n<div class=\"page_header\">\n<a href=\"\">\n<img src=\"\" "
  "alt=\"VDR Live!\" class=\"logo\"></img></a>\n</div>\n<div style=\"clear: both\"></div>\n\n\n\nstyle=\"visibility: hid"
  "den\"\n\n\n<div class=\"\"><div class=\"__elapsed\" id=\"\"style=\"width: px\"></div></div>\n\n\n\n<a id=\"\"  href="
  "\"vdr_request/\?param=\"  ><img src=\"\" alt=\"\"></img></a> \n\n\n<a href=\"http://www.imdb.com/find\?s=all&q=\"\n<a"
  " href=\"http://www.imdb.com/title/\"\n target=\"_blank\"><img src=\"\" alt=\"\" ></img></a> \n\n\n<a href=\"stream.ht"
  "ml\?channelid_str=\"><img src=\"\" alt=\"\" ></img></a>\n\n\n\n<a href=\"playlist.m3u\?channel_str=\"><img src=\"\" a"
  "lt=\"\" ></img></a>\n<a href=\"playlist.m3u\?channel=\"><img src=\"\" alt=\"\" ></img></a>\n\n\n\n<a href=\"playlist."
  "m3u\?recid=\"><img src=\"\" alt=\"\" ></img> </a>\n\n\n\n\t\t\n\t\t<a href=\"edit_timer.html\?epgid=\"><img src=\"\" "
  "alt=\"\"  /></a>\n\n\n\n\t<a href=\"edit_timer.html\?timerid=\"><img src=\"\" alt=\"\"  /></a>\n\n\n\n\n\t<script typ"
  "e=\"text/javascript\" src=\"js/mootools/mootools.v1.11.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/li"
  "ve/liveajax.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/infowin.js\"></script>\n\t<script type="
  "\"text/javascript\" src=\"js/live/hinttips.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/browserwi"
  "n.js\"></script>\n\t<script type=\"text/javascript\" src=\"js/live/pageenhance.js\"></script>\n\t<script type=\"text/"
  "javascript\"><!--\n\t\tvar liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/tra"
  "nsparent.png',\n\t\t\t\t\tloadingMsg: '',\n\t\t\t\t\terrorMsg: ''\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsu"
  "ccessMsg: '<img src=\"\" alt=\"\"> ',\n\t\t\t\t\terrorMsg: '<img src=\"\" alt=\"\"> '\n\t\t\t\t}\n\t\t\t});\n\t--></s"
  "cript>\n\t<script type=\"text/javascript\" src=\"js/live/vdr_status.js\"></script>\n\t<script type=\"text/javascript"
  "\"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t"
  "\tInfoBox.request();\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t-"
  "-></script>\n\n\n\n<div id=\"infobox\">\n\t<div class=\"statuscontent\">\n\t\t<div class=\"st_header\">\n\t\t\t<div i"
  "d=\"infobox_caption\" class=\"caption\"></div>\n\t\t\t<div id=\"infobox_timenow\" class=\"now\">--:--</div>\n\t\t</di"
  "v>\n\t\t<div class=\"st_content\">\n\t\t\t<div id=\"infobox_name\" class=\"name\"></div>\n\t\t\t<div id=\"infobox_dur"
  "ation\" class=\"duration\">--:--</div>\n\t\t</div>\n\t\t<div class=\"st_controls\">\n\t\t\t<div class=\"st_update\">"
  "\n\t\t\t\t<a href=\"javascript:InfoBox.toggleUpdate()\" ><img id=\"statusReloadBtn\" src=\"\" alt=\"\" /></a>\n\t\t\t"
  "</div>\n\t\t\t<div id=\"infobox_recording_buttons\" style=\"display: none\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t\n\t\t\t\t"
  "\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div id=\"infobox_channel_buttons\">\n\t\t\t\t\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div cl"
  "ass=\"st_pbar\">\n\t\t\t\t\n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style=\"display: none;\">\n\t\t<span id=\"__in"
  "fobox_request_err\"></span>\n\t\t<span id=\"__infobox_update_err\"></span>\n\t</div>\n</div>\n\n\n\n\t\n\t  \n\t<a hr"
  "ef=\"searchresults.html\?searchplain=\"><img src=\"\" alt=\"\" ></img></a>\n\t\n\t\n\t\t\n<img data-src=\"img/transpa"
  "rent.png\" height=\"10px\" />\n<span id=\"icons-\"></span>\n\n\t\t\t\t\t<script class=\"injectIcons\">\n\t\t\t\t\tinj"
  "ectHdSdIcon(\"icons-\", \"\", \"\")\n\t\t\t\t\t</script>\n\t\t<td class=\"action leftcol \"></td>\n\t\t<td class=\"ac"
  "tion \"></td>\n\t\t\t\t<td class=\"action \">\n\t\t\t\t\t\t<a href=\"searchresults.html\?searchplain=\"><img src=\"\""
  " alt=\"\" ></img></a></td>\n\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t<td class=\"action \"></td>\n\t\t\t\t<td cla"
  "ss=\"action \">\n\t\t\t\n\t\t</td>\n\n\n\n\t<div class=\"epg_description\" id=\"\">\n\t\t<div class=\"station\">\n\t"
  "\t\t<div class=\"boxheader\">\n\n<div>\n<div class = \"caption menu\">\n  <a id=\"_epg_m\"     class = \"active\"   o"
  "nclick=\"displayEPG('')\" ></a>\n| <a id=\"_scraper_m\" class = \"inactive\" onclick=\"displayScraper('')\"></a>\n| <"
  "a id=\"_actors_m\"  class = \"inactive\" onclick=\"displayActors('')\" ></a>\n| <a id=\"_artwork_m\" class = \"inacti"
  "ve\" onclick=\"displayArtwork('')\" ></a>\n</div>\n<div class=\"caption\"></div>\n</div>\n                        </d"
  "iv>\n\t\t</div>\n\t\t<div class=\"epg_content\">\n\t\t\t<div class=\"epg_tools\">\n\t\t\t\t\n\t\t\t</div>\n\t\t\t<div"
  " class=\"epg_info\">\n\t\t\t\t<div class=\"info\">\n\t\t\t\t\t<div class=\"duration\">\n\t\t\t\t\t\t<span title=\"\">"
  "</span> / <span title=\"\"></span>\n\t\t\t\t\t\t<div class=\"progress\"><div></div></div>\n\t\t\t\t\t</div>\n\t\t\t\t"
  "\t<div class=\"time\">\n              <span class=\"bold\"></span>\n            \n              <div class=\"channel"
  "\"></div>\n\t\t\t\t\t</div>\n\t\t\t\t\t<div class=\"title\"></div>\n\t\t\t\t\t<div class=\"short\"></div>\n\t\t\t\t\t"
  "<div class=\"description\" id=_description>\n\t\t\t\t\t<span id = \"_epg_image\" class=\"epg_images\">\n         <a h"
  "ref=\"/epgimages/\" target=\"_blank\">\n\t\t\t\t\t\t<img src=\"/epgimages/\" class=\"epg_image\"/>\n         </a>\n  "
  "  <a href=\"/tvscraper/\" target=\"_blank\">\n\t    <img src=\"/tvscraper/\" class=\"epg_image\"/>\n    </a>\n      <"
  "a href=\"/tvscraper/\" target=\"_blank\">\n        <img src=\"/tvscraper/\" class=\"epg_image\"/>\n      </a>\n      "
  "<a href=\"/recimages//\" target=\"_blank\">\n\t\t\t\t<img src=\"/recimages//\" class=\"epg_image\"/>\n      </a>\n\t"
  "\t\t\t\t</span> \n\n\n<div id = '_scraper' hidden>\n  <div class=\"scraper_list\">         </div>\n  <div class=\"scr"
  "aper_list\"> </div>\n    <div class=\"scraper_list\"> SE </div>\n    <div class=\"scraper_list\">   </div>\n      <di"
  "v class=\"scraper_list\">  / </div>\n    <div class=\"scraper_list\"> </div>\n      <div class=\"scraper_list\"> </di"
  "v>\n\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n      <div class=\"scraper_list\"></div"
  ">\n      <table>\n      <tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n      <tr>\n"
  "        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n      <tr>\n        <td class=\"cast_role"
  "\">  </td>\n        <td>  </td>\n      </tr>\n      </table>\n  <div class=\"scraper_list\">        </div>\n  <div cl"
  "ass=\"scraper_list\">       </div>\n  <div class=\"scraper_list\">         </div>\n  <div class=\"scraper_list\"><a h"
  "ref =\"\" target=\"_blank\"></a></div>\n  <div class=\"scraper_list\">   </div>\n  <div class=\"scraper_list\">      "
  "  </div>\n  <div class=\"scraper_list\">     </div>\n  <div class=\"scraper_list\">  / </div>\n\n    <div class=\"scr"
  "aper_list\">\n      <a href=\"https://www.imdb.com/title/\" target=\"_blank\">  </a>\n    </div>\n\n    <div class=\""
  "scraper_list\">         </div>\n    <div class=\"scraper_list\">        </div>\n\n    <div class=\"scraper_list\"> </"
  "div>\n    <div class=\"scraper_list\">         </div>\n\n    <div class=\"scraper_list\"></div>\n    <table>\n      <"
  "tr>\n        <td class=\"cast_role\">  </td>\n        <td>  </td>\n      </tr>\n        <tr>\n          <td class=\"c"
  "ast_role\">  </td>\n          <td>  </td>\n        </tr>\n        <tr>\n          <td class=\"cast_role\">  </td>\n  "
  "        <td>  </td>\n        </tr>\n  </table>\n</div>\n\n<div id = '_actors' hidden>\n<table>\n      <tr>\n    <td>"
  "\n      <a href=\"/tvscraper/\" target=\"_blank\">\n        <img src=\"/tvscraper/\" alt=\": \" class=\"actor\">\n   "
  "     </img>\n      </a>\n    </td>\n      </tr>\n      <tr></tr>\n    </tr>\n    <tr></tr>\n</table>\n</div>\n\n<div "
  "id = '_artwork' hidden>\n\n\n\n</div>\n\n<div id = '_epg'>\n\t\t\t\t\t\t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</d"
  "iv>\n</div>\n\n\n  <a href=\"/tvscraper/\" target=\"_blank\">\n    <img src=\"/tvscraper/\" class=\"artwork\">\n    <"
  "/img>\n  </a>\n\n\n\t<div class=\"epg_description\" id=\"aboutBox\">\n\t\t<div class=\"station\">\n\t\t\t<div class="
  "\"boxheader\"><div><div class=\"caption\"></div></div></div>\n\t\t</div>\n\t\t<div class=\"epg_content\">\n\t\t\t<div"
  ">\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t"
  "\t<div class=\"about_right\">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div clas"
  "s=\"about_right\">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class="
  "\"about_right\">Markus Ehrnsperger (MarkusE @ <a href=\"https://www.vdr-portal.de\">VDR Portal</a>)</div>\n\t\t\t\t<d"
  "iv class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div clas"
  "s=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class=\"about"
  "_left\">:</div>\n\t\t\t\t<div class=\"about_right\">Christian Wieninger (winni)</div>\n\t\t\t\t<div class=\"about_lef"
  "t\">:</div>\n\t\t\t\t<div class=\"about_right\">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class=\"about_"
  "head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\"></"
  "div>\n\t\t\t\t<div class=\"about_left\">:</div>\n\t\t\t\t<div class=\"about_right\"></div>\n\t\t\t\t<div class=\"abou"
  "t_head\"><div><div></div></div></div>\n\t\t\t\t<div class=\"about_left\">EPGsearch:</div>\n\t\t\t\t<div class=\"about"
  "_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://g"
  "ithub.com/vdr-projects/vdr-plugin-epgsearch\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"abou"
  "t_left\">Streamdev server:</div>\n\t\t\t\t<div class=\"about_right\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t"
  "\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://github.com/vdr-projects/vdr-plugin-streamdev\" target=\"_b"
  "lank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_left\">tvscraper:</div>\n\t\t\t\t<div class=\"about_rig"
  "ht\">\n\t\t\t\t\t<img align=\"center\" src=\"\"/>\n\t\t\t\t\t\t: \n\t\t\t\t\t\t: \n\t\t\t\t\t(<a href=\"https://githu"
  "b.com/MarkusEh/vdr-plugin-tvscraper\" target=\"_blank\"></a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class=\"about_head\""
  "><div><div></div></div></div>\n\t\t\t\t<div class=\"about_line\">Movie information provided by <a target=\"_blank\" h"
  "ref=\"https://www.themoviedb.org/\">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB"
  "</div>\n\t\t\t\t<div class=\"about_line\">Information provided by TheTVDB.com. Please consider <a target=\"_blank\" h"
  "ref=\"https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavF"
  "beqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva"
  "30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P"
  "-2BiKLECU3LgttsntUcN8fnUs-3D\">supporting them</a></div>\n\t\t\t\t<div class=\"about_head\"><div><div></div></div></d"
  "iv>\n\t\t\t\t<div class=\"about_line\">:<br/>\n\t\t\t\t\t<a target=\"_blank\" href=\"https://github.com/MarkusEh/vdr-"
  "plugin-live/issues\">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class=\"about_head\">"
  "<div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl),
    doc_type(*this, "doc_type"),
    create_html_js(*this, "create_html_js"),
    stylesheets(*this, "stylesheets"),
    logo(*this, "logo"),
    hide_element(*this, "hide_element"),
    progressbar(*this, "progressbar"),
    ajax_action_href(*this, "ajax_action_href"),
    imdb_info_href(*this, "imdb_info_href"),
    hls_channel(*this, "hls_channel"),
    m3u_playlist_channel(*this, "m3u_playlist_channel"),
    m3u_playlist_recording(*this, "m3u_playlist_recording"),
    event_timer(*this, "event_timer"),
    edit_timer(*this, "edit_timer"),
    ajax_js(*this, "ajax_js"),
    infobox(*this, "infobox"),
    epg_tool_box(*this, "epg_tool_box"),
    epg_tt_box(*this, "epg_tt_box"),
    media(*this, "media"),
    about_tt_box(*this, "about_tt_box")
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[0]; // \n
  reply.out() << _tntChunks[1]; // \n\n
  reply.out() << _tntChunks[3]; // \n
  reply.out() << _tntChunks[4]; // \n\n
  reply.out() << _tntChunks[40]; // \n\n
  reply.out() << _tntChunks[43]; // \n
  reply.out() << _tntChunks[44]; // \n\n
  reply.out() << _tntChunks[51]; // \n
  reply.out() << _tntChunks[52]; // \n\n
  reply.out() << _tntChunks[54]; // \n
  reply.out() << _tntChunks[55]; // \n\n
  reply.out() << _tntChunks[62]; // \n
  reply.out() << _tntChunks[63]; // \n\n
  reply.out() << _tntChunks[74]; // \n
  reply.out() << _tntChunks[75]; // \n\n
  reply.out() << _tntChunks[83]; // \n
  reply.out() << _tntChunks[84]; // \n\n
  reply.out() << _tntChunks[89]; // \n
  reply.out() << _tntChunks[90]; // \n\n
  reply.out() << _tntChunks[99]; // \n
  reply.out() << _tntChunks[100]; // \n\n
  reply.out() << _tntChunks[106]; // \n
  reply.out() << _tntChunks[107]; // \n\n
  reply.out() << _tntChunks[114]; // \n
  reply.out() << _tntChunks[115]; // \n\n
  reply.out() << _tntChunks[120]; // \n\n
  reply.out() << _tntChunks[121]; // \n\n
  reply.out() << _tntChunks[131]; // \n
  reply.out() << _tntChunks[132]; // \n\n
  reply.out() << _tntChunks[147]; // \n
  reply.out() << _tntChunks[148]; // \n\n
  reply.out() << _tntChunks[192]; // \n
  reply.out() << _tntChunks[193]; // \n\n
  reply.out() << _tntChunks[368]; // \n
  reply.out() << _tntChunks[369]; // \n
  reply.out() << _tntChunks[373]; // \n\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::doc_type_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::doc_type " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[2]; // <!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::create_html_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::create_html_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 63 "pageelems.ecpp"

const char *lf;
if (LiveSetup().GetUseAjax()) lf = "<br/>";
else lf = "&#13;";

  reply.out() << _tntChunks[5]; // <script type="text/javascript" src="js/live/createHtml.js"></script>\n<script>\nfunction addErrorIcon(s, numErrors, durationDeviation, duration) {\n  if (numErrors <= -100) return\n  s.a += '<div class="recording_errors"><img class="icon" src="
#line 72 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[6]; // '\n  if (durationDeviation > 300 || numErrors  > 0) s.a += 'RecordingErrors.png'\n  else if (durationDeviation > 60) s.a += 'NotCheckedForRecordingErrors.png'\n  else {\n    if (numErrors == 0) s.a += 'NoRecordingErrors.png'\n    if (numErrors  > 0) s.a += 'RecordingErrors.png'\n    if (numErrors  < 0) s.a += 'NotCheckedForRecordingErrors.png'\n  }\n  s.a += '" width = "16px" title="'\n  if (numErrors == 0) s.a += '
#line 81 "pageelems.ecpp"
  reply.sout() << (tr("No recording errors"));
  reply.out() << _tntChunks[7]; // '\n  if (numErrors  > 0) s.a += '
#line 82 "pageelems.ecpp"
  reply.sout() << (tr("Number of recording errors:"));
  reply.out() << _tntChunks[8]; //  ' + String(numErrors)\n  if (numErrors  < 0) s.a += '
#line 83 "pageelems.ecpp"
  reply.sout() << (tr("Recording errors unknown"));
  reply.out() << _tntChunks[9]; // '\n  s.a += '
#line 84 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[10]; // '\n  s.a += '
#line 85 "pageelems.ecpp"
  reply.sout() << (tr("Duration deviation from event length"));
  reply.out() << _tntChunks[11]; // '\n  s.a += ': '\n  addTime(s, durationDeviation)\n  s.a += ' '\n  s.a += '
#line 89 "pageelems.ecpp"
  reply.sout() << (tr("min"));
  reply.out() << _tntChunks[12]; // '\n  s.a += '
#line 90 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[13]; // '\n  s.a += '
#line 91 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[14]; // '\n  s.a += ': '\n  s.a += duration\n  s.a += ' '\n  s.a += '
#line 95 "pageelems.ecpp"
  reply.sout() << (tr("h"));
  reply.out() << _tntChunks[15]; // '\n  s.a += '" /> </div>'\n}\n\nfunction addHdSdIcon(s, hdsd, toolTip) {\n  s.a += '<div class="recording_sd_hd"><img class="icon" src="
#line 100 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[16]; // '\n  s.a += hdsd\n  s.a += 'd.png" width = "25px" title="'\n  s.a += toolTip\n  s.a += '" /></div>'\n}\n\nfunction IMDBS(s, im_db, name) {\n  if (im_db.length == 0) {\n    s.a += '<a href="http://www.imdb.com/find\?s=all&q='\n    s.a += name\n  } else {\n    s.a += '<a href="https://www.imdb.com/title/'\n    s.a += im_db\n  }\n  s.a += \n   '" target="_blank"><img class="icon" src="
#line 116 "pageelems.ecpp"
  reply.sout() << (LiveSetup().GetThemedLinkPrefixImg());
  reply.out() << _tntChunks[17]; // imdb.png" title="
#line 116 "pageelems.ecpp"
  reply.sout() << (tr("Find more at the Internet Movie Database."));
  reply.out() << _tntChunks[18]; // "/></a>'\n}\n\n
  reply.out() << _tntChunks[19]; // \nfunction addEvent(s, bottomrow_i, obj) {\n// first column, timer /red or green, ...\n  let bottomrow = ''\n  if (bottomrow_i != 0) bottomrow = 'bottomrow'\n  s.a += `<tr><td class="action leftcol ${bottomrow}">`\n  if (obj[1].length != 0) {\n    s.a += '<a href="edit_timer.html\?timerid=timer_'\n    s.a += obj[1]\n    s.a += '"><img class="icon" src="
#line 145 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record_timer.png") );
  reply.out() << _tntChunks[20]; // " title="
#line 145 "pageelems.ecpp"
  reply.sout() << (tr("Edit timer"));
  reply.out() << _tntChunks[21]; // " />'\n  } else {\n    s.a += '<a href="edit_timer.html\?epgid=event_'\n    s.a += obj[0]\n    s.a += '"><img class="icon" src="
#line 149 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[22]; // " title="
#line 149 "pageelems.ecpp"
  reply.sout() << (tr("Record this"));
  reply.out() << _tntChunks[23]; // " />'\n  }\n  s.a += '</a>'\n
#line 152 "pageelems.ecpp"
if (LiveFeatures<features::epgsearch>().Recent() ) { 
  reply.out() << _tntChunks[24]; //   s.a += '<a href="searchresults.html\?searchplain='\n  s.a += obj[11]\n  s.a += '"><img class="icon" src="
#line 155 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[25]; // " title="
#line 155 "pageelems.ecpp"
  reply.sout() << (tr("Search for repeats."));
  reply.out() << _tntChunks[26]; // "/></a>'\n
#line 156 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[27]; //   IMDBS(s, obj[2], obj[11])\n
#line 158 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[28]; //   s.a += '</td>'\n// second col, dependent on width: channel\n  if (obj[9] > 0) {\n    s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin"><a href="schedule.html\?channel=`\n    s.a += obj[9]\n    s.a += '">'\n    s.a += obj[10]\n    s.a += '</a></div></td>'\n  }\n// third col: image\n
#line 169 "pageelems.ecpp"
 if (!LiveSetup().GetTvscraperImageDir().empty() ) { 
  reply.out() << _tntChunks[29]; //     s.a += `<td class="enlarge-image ${bottomrow}">`\n    addScraperImageTitle(s, obj[3], obj[4], obj[5], obj[6], obj[7], obj[8], '
#line 171 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[30]; // ');\n    s.a += '</td>'\n
#line 173 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[31]; //   s.a += `<td class="td-hidden-xs ${bottomrow}"><div class="hidden-xs withmargin">`\n  s.a += obj[14]\n  s.a += '</div></td>'\n// col with times, channel, name, short text\n  s.a += `<td class="rightcol ${bottomrow}"><div class="withmargin">`\n// first line: link to channel, times, channel\n  s.a += '<div class="margin-bottom display-xs">'\n  if (obj[9] > 0) {\n    s.a += '<a href="schedule.html\?channel='\n    s.a += obj[9]\n    s.a += '">'\n  }\n  s.a += '<span class="normal-font">'\n  s.a += obj[14]\n  if (obj[9] > 0) {\n    s.a += ' '\n    s.a += obj[10]\n  }\n  s.a += '</span>'\n  if (obj[9] > 0) s.a += '</a>'\n  s.a += '</div>'\n// sec&third line: Link to event, event title, short text\n  addEventRec(s, 'event_', obj[0], obj[11], '', obj[12], obj[13], '
#line 196 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[32]; // ', '
#line 196 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[33]; // ')\n  s.a += '</div></td></tr>'\n}\nfunction eventString(bottomrow, data) {\n  const s = Object.create(null)\n  s.a = ""\n  addEvent(s, bottomrow, data)\n  return s.a\n}\n\n// existing recording\nfunction existingRecordingSR(s, col_span1, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration) {\n  if (archiveDescr.length != 0) col_span1--;\n  s.a += '<tr><td colspan='\n  s.a += col_span1.toString()\n  s.a += ' class="leftcol '\n  s.a += bottomrow\n  s.a += '">
#line 213 "pageelems.ecpp"
  reply.sout() << ( tr("Existing Recording:") );
  reply.out() << _tntChunks[34]; // '\n  if (archiveDescr.length != 0) {\n    s.a += '</td><td class="action '\n    s.a += bottomrow\n    s.a += '"> <img class="icon" src="
#line 217 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "on_dvd.png") );
  reply.out() << _tntChunks[35]; // " alt="on dvd" title=" />'\n    s.a += archiveDescr\n    s.a += '/>'\n
#line 220 "pageelems.ecpp"

#if VDRVERSNUM >= 20505

  reply.out() << _tntChunks[36]; //   } else {\n    s.a += '<br/><table><tr><td class="noborder">'\n    addErrorIcon(s, errors, durationDeviation, duration)\n    s.a += '</td><td class="noborder">'\n    addHdSdIcon(s, hd_sd, channel_name)\n    s.a += '</td></tr></table>'\n
#line 229 "pageelems.ecpp"

#endif

  reply.out() << _tntChunks[37]; //   }\n  s.a += '</td><td class="td-hidden-xs '\n  s.a += bottomrow\n  s.a += '"><div class="hidden-xs recording_day">'\n  s.a += day_time_duration\n  s.a += '</div></td><td class="rightcol '\n  s.a += bottomrow\n  s.a += '">'\n  addColEventRec(s, day_time_duration, 'recording_', id, name, folder, short_text, description, '
#line 240 "pageelems.ecpp"
  reply.out() << (lf);
  reply.out() << _tntChunks[38]; // ', '
#line 240 "pageelems.ecpp"
  reply.sout() << (tr("Click to view details."));
  reply.out() << _tntChunks[39]; // ')\n  s.a += '</td></tr>'\n}\nfunction existingRecordingString(col_span, bottomrow, id, archiveDescr, imdb_id, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration) {\n  const s = Object.create(null)\n  s.a = ""\n  existingRecordingSR(s, col_span, bottomrow, imdb_id, id, archiveDescr, image, pt, s_title, s_season_episode, s_runtime, s_date, day_time_duration, errors, hd_sd, channel_name, newR, name, short_text, description, durationDeviation, folder, duration)\n  return s.a\n}\n\n\n</script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::stylesheets_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::stylesheets " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[41]; // <link rel="stylesheet" type="text/css" href="css/styles.css"/>\n<link rel="stylesheet" type="text/css" href="
#line 257 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("css", "theme.css") );
  reply.out() << _tntChunks[42]; // "/>\n<link rel="stylesheet" type="text/css" href="css/siteprefs.css"/>\n<script type="text/javascript" src="js/live/header.js"></script>\n<script type="text/javascript" src="js/live/epg_tt_box.js"></script>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::logo_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::logo " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[45]; // <!-- start of fixed page header -->\n<div id="header" style="width: 100%; background-color: inherit">\n<div id="padding" style="display: none"></div>\n<div id="content">\n<!-- header content follows -->\n
#line 271 "pageelems.ecpp"

	if (LiveSetup().GetShowLogo()
		|| (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox())) {

  reply.out() << _tntChunks[46]; // <div class="page_header">\n
#line 276 "pageelems.ecpp"

		if (LiveSetup().GetShowLogo()) {

  reply.out() << _tntChunks[47]; // <a href="
#line 279 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetStartScreenLink());
  reply.out() << _tntChunks[48]; // ">\n<img src="
#line 280 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "logo.png") );
  reply.out() << _tntChunks[49]; // " alt="VDR Live!" class="logo"></img></a>\n
#line 281 "pageelems.ecpp"

		}

#line 284 "pageelems.ecpp"
if (LiveSetup().GetUseAjax() && LiveSetup().GetShowInfoBox()) { 
  // <& infobox ...
  { 
#line 284 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 284 "pageelems.ecpp"
  main().infobox(request, reply, _tnt_cq0);
    // &>
  }
#line 284 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[50]; // </div>\n<div style="clear: both"></div>\n
#line 287 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hide_element_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hide_element " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int hide = qparam.get< int >("hide", ( 1));
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 298 "pageelems.ecpp"
 if (hide) { 
  reply.out() << _tntChunks[53]; // style="visibility: hidden"
#line 298 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::progressbar_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::progressbar " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int progress = qparam.get< int >("progress", ( 0));
std::string id = qparam.get< std::string >("id");
int duration = qparam.get< int >("duration", ( -1));
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 309 "pageelems.ecpp"

	std::string cls("__progress");
	if ((duration >= 0) && ((progress < 0) || (duration == 0)))
		cls +="_invisible";

  reply.out() << _tntChunks[56]; // <div class="
#line 314 "pageelems.ecpp"
  reply.sout() << ( cls );
  reply.out() << _tntChunks[57]; // "><div class="__elapsed" 
#line 314 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[58]; // id="
#line 314 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[59]; // "
#line 314 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[60]; // style="width: 
#line 314 "pageelems.ecpp"
  reply.sout() << ( progress );
  reply.out() << _tntChunks[61]; // px"></div></div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_action_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_action_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string action = qparam.get< std::string >("action");
std::string tip = qparam.get< std::string >("tip");
std::string param = qparam.get< std::string >("param");
std::string image = qparam.get< std::string >("image");
std::string alt = qparam.get< std::string >("alt");
std::string id = qparam.get< std::string >("id");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 328 "pageelems.ecpp"
 { 
  reply.out() << _tntChunks[64]; // <a 
#line 328 "pageelems.ecpp"
 if (!id.empty()) { 
  reply.out() << _tntChunks[65]; // id="
#line 328 "pageelems.ecpp"
  reply.sout() << ( id );
  reply.out() << _tntChunks[66]; // " 
#line 328 "pageelems.ecpp"
 } 
  // <& hide_element ...
  { 
#line 328 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq1;
#line 328 "pageelems.ecpp"
    _tnt_cq1.add( "hide", (id.empty()? 0 : 1));
#line 328 "pageelems.ecpp"
  main().hide_element(request, reply, _tnt_cq1);
    // &>
  }
  reply.out() << _tntChunks[67]; //  href="vdr_request/
#line 328 "pageelems.ecpp"
  reply.sout() << ( action );
  reply.out() << _tntChunks[68]; // \?param=
#line 328 "pageelems.ecpp"
  reply.sout() << ( param );
  reply.out() << _tntChunks[69]; // " 
#line 328 "pageelems.ecpp"
if (!tip.empty()) { 
  // <& tooltip.hint ...
  { 
#line 328 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq2;
#line 328 "pageelems.ecpp"
    _tnt_cq2.add( "text", (tip));
#line 328 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq2);
    // &>
  }
  reply.out() << _tntChunks[70]; //  
#line 328 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[71]; // ><img src="
#line 328 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", image) );
  reply.out() << _tntChunks[72]; // " alt="
#line 328 "pageelems.ecpp"
  reply.sout() << ( alt );
  reply.out() << _tntChunks[73]; // "></img></a> 
#line 328 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::imdb_info_href_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::imdb_info_href " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string title = qparam.get< std::string >("title");
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 338 "pageelems.ecpp"

// if (LiveSetup().GetShowIMDb())
{
if (s_IMDB_ID.empty() ) { 
  reply.out() << _tntChunks[76]; // <a href="http://www.imdb.com/find\?s=all&q=
#line 342 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[77]; // "\n
#line 343 "pageelems.ecpp"
 } else { 
  reply.out() << _tntChunks[78]; // <a href="http://www.imdb.com/title/
#line 344 "pageelems.ecpp"
  reply.sout() << ( s_IMDB_ID );
  reply.out() << _tntChunks[79]; // "\n
#line 345 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[80]; //  target="_blank"><img src="
#line 346 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "imdb.png") );
  reply.out() << _tntChunks[81]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 346 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq3;
#line 346 "pageelems.ecpp"
    _tnt_cq3.add( "text", (tr("Find more at the Internet Movie Database.")));
#line 346 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq3);
    // &>
  }
  reply.out() << _tntChunks[82]; // ></img></a> 
#line 346 "pageelems.ecpp"
 } 
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::hls_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::hls_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 355 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {

  reply.out() << _tntChunks[85]; // <a href="stream.html\?channelid_str=
#line 358 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[86]; // "><img src="
#line 358 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stream_button.png") );
  reply.out() << _tntChunks[87]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 358 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq4;
#line 358 "pageelems.ecpp"
    _tnt_cq4.add( "text", (tr("Stream this channel into browser.")));
#line 358 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq4);
    // &>
  }
  reply.out() << _tntChunks[88]; // ></img></a>\n
#line 359 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_channel_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_channel " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string channelId = qparam.get< std::string >("channelId");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 370 "pageelems.ecpp"

if (LiveSetup().GetUseStreamdev() && LiveFeatures<features::streamdev_server>().Loaded()) {
#if TNTVERSION >= 30000

  reply.out() << _tntChunks[91]; // <a href="playlist.m3u\?channel_str=
#line 374 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[92]; // "><img src="
#line 374 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[93]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 374 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq5;
#line 374 "pageelems.ecpp"
    _tnt_cq5.add( "text", (tr("Stream this channel into media player.")));
#line 374 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq5);
    // &>
  }
  reply.out() << _tntChunks[94]; // ></img></a>\n
#line 375 "pageelems.ecpp"

#else

  reply.out() << _tntChunks[95]; // <a href="playlist.m3u\?channel=
#line 378 "pageelems.ecpp"
  reply.sout() << ( channelId );
  reply.out() << _tntChunks[96]; // "><img src="
#line 378 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[97]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 378 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq6;
#line 378 "pageelems.ecpp"
    _tnt_cq6.add( "text", (tr("Stream this channel into media player.")));
#line 378 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq6);
    // &>
  }
  reply.out() << _tntChunks[98]; // ></img></a>\n
#line 379 "pageelems.ecpp"

#endif
}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::m3u_playlist_recording_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::m3u_playlist_recording " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string recid = qparam.get< std::string >("recid");
std::string linkText = qparam.get< std::string >("linkText");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 392 "pageelems.ecpp"

#if TNT_WATCHDOG_SILENCE
{

  reply.out() << _tntChunks[101]; // <a href="playlist.m3u\?recid=
#line 395 "pageelems.ecpp"
  reply.sout() << ( recid );
  reply.out() << _tntChunks[102]; // "><img src="
#line 395 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "playlist.png") );
  reply.out() << _tntChunks[103]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 395 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq7;
#line 395 "pageelems.ecpp"
    _tnt_cq7.add( "text", (tr("Stream this recording into media player.")));
#line 395 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq7);
    // &>
  }
  reply.out() << _tntChunks[104]; // ></img> 
#line 395 "pageelems.ecpp"
  reply.sout() << ( linkText );
  reply.out() << _tntChunks[105]; // </a>\n
#line 396 "pageelems.ecpp"

}
#endif

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::event_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::event_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string epgid = qparam.get< std::string >("epgid");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 408 "pageelems.ecpp"

	tChannelID channelid;
	tEventID eventid;
	EpgEvents::DecodeDomId(epgid, channelid, eventid);
	const cTimer* timer = LiveTimerManager().GetTimer(eventid, channelid);
	if (timer) {

  reply.out() << _tntChunks[108]; // \t\t
  // <& pageelems.edit_timer ...
  { 
#line 415 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq8;
#line 415 "pageelems.ecpp"
    _tnt_cq8.add( "imgName", ("record_timer.png"));
#line 415 "pageelems.ecpp"
    _tnt_cq8.add( "timerId", (LiveTimerManager().GetTimers().GetTimerId(*timer)));
#line 415 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "edit_timer"), request, reply, _tnt_cq8);
    // &>
  }
  reply.out() << _tntChunks[109]; // \n
#line 416 "pageelems.ecpp"

	}
	else {

  reply.out() << _tntChunks[110]; // \t\t<a href="edit_timer.html\?epgid=
#line 420 "pageelems.ecpp"
  reply.sout() << ( epgid );
  reply.out() << _tntChunks[111]; // "><img src="
#line 420 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "record.png") );
  reply.out() << _tntChunks[112]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 420 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq9;
#line 420 "pageelems.ecpp"
    _tnt_cq9.add( "text", (tr("Record this")));
#line 420 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq9);
    // &>
  }
  reply.out() << _tntChunks[113]; //  /></a>\n
#line 421 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::edit_timer_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::edit_timer " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string timerId = qparam.get< std::string >("timerId");
std::string imgName = qparam.get< std::string >("imgName", ( "edit.png"));
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[116]; // \t<a href="edit_timer.html\?timerid=
#line 433 "pageelems.ecpp"
  reply.sout() << ( SortedTimers::EncodeDomId(timerId) );
  reply.out() << _tntChunks[117]; // "><img src="
#line 433 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", imgName) );
  reply.out() << _tntChunks[118]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 433 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq10;
#line 433 "pageelems.ecpp"
    _tnt_cq10.add( "text", (tr("Edit timer")));
#line 433 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq10);
    // &>
  }
  reply.out() << _tntChunks[119]; //  /></a>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::ajax_js_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::ajax_js " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 440 "pageelems.ecpp"

	if (LiveSetup().GetUseAjax()) {

  reply.out() << _tntChunks[122]; // \t<script type="text/javascript" src="js/mootools/mootools.v1.11.js"></script>\n\t<script type="text/javascript" src="js/live/liveajax.js"></script>\n\t<script type="text/javascript" src="js/live/infowin.js"></script>\n\t<script type="text/javascript" src="js/live/hinttips.js"></script>\n\t<script type="text/javascript" src="js/live/browserwin.js"></script>\n\t<script type="text/javascript" src="js/live/pageenhance.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar liveEnhanced = new PageEnhance({\n\t\t\t\tinfoWinOptions: {\n\t\t\t\t\tbuttonimg: 'img/transparent.png',\n\t\t\t\t\tloadingMsg: '
#line 453 "pageelems.ecpp"
  reply.sout() << ( tr("loading data") );
  reply.out() << _tntChunks[123]; // ',\n\t\t\t\t\terrorMsg: '
#line 454 "pageelems.ecpp"
  reply.sout() << ( tr("an error occured!") );
  reply.out() << _tntChunks[124]; // '\n\t\t\t\t},\n\t\t\t\tnotifyStrings: {\n\t\t\t\t\tsuccessMsg: '<img src="
#line 457 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "active.png") );
  reply.out() << _tntChunks[125]; // " alt=""> 
#line 457 "pageelems.ecpp"
  reply.sout() << ( tr("Request succeeded!") );
  reply.out() << _tntChunks[126]; // ',\n\t\t\t\t\terrorMsg: '<img src="
#line 458 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "del.png") );
  reply.out() << _tntChunks[127]; // " alt=""> 
#line 458 "pageelems.ecpp"
  reply.sout() << ( tr("Request failed!") );
  reply.out() << _tntChunks[128]; // '\n\t\t\t\t}\n\t\t\t});\n\t--></script>\n
#line 462 "pageelems.ecpp"

		if (LiveSetup().GetShowInfoBox()) {

  reply.out() << _tntChunks[129]; // \t<script type="text/javascript" src="js/live/vdr_status.js"></script>\n\t<script type="text/javascript"><!--\n\t\tvar InfoBox = new LiveVdrInfo('ibox.xml', 'infobox');\n\t\twindow.addEvent('domready', function(){\n\t\t\tInfoBox.request(
#line 469 "pageelems.ecpp"
 if (update_status) { reply.sout() << "true"; } else { reply.sout() << "false"; } 
  reply.out() << _tntChunks[130]; // );\n\t\t});\n\t\twindow.addEvent('unload', function(){\n\t\t\tInfoBox.pageFinished();\n\t\t});\n\t--></script>\n
#line 475 "pageelems.ecpp"

		}

#line 478 "pageelems.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::infobox_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::infobox " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[133]; // <div id="infobox">\n\t<div class="statuscontent">\n\t\t<div class="st_header">\n\t\t\t<div id="infobox_caption" class="caption">
#line 489 "pageelems.ecpp"
  reply.sout() << ( tr("retrieving status ...") );
  reply.out() << _tntChunks[134]; // </div>\n\t\t\t<div id="infobox_timenow" class="now">--:--</div>\n\t\t</div>\n\t\t<div class="st_content">\n\t\t\t<div id="infobox_name" class="name"></div>\n\t\t\t<div id="infobox_duration" class="duration">--:--</div>\n\t\t</div>\n\t\t<div class="st_controls">\n\t\t\t<div class="st_update">\n\t\t\t\t<a href="javascript:InfoBox.toggleUpdate()" 
  // <& tooltip.hint ...
  { 
#line 498 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq11;
#line 498 "pageelems.ecpp"
    _tnt_cq11.add( "text", (tr("Toggle updates on/off.")));
#line 498 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq11);
    // &>
  }
  reply.out() << _tntChunks[135]; // ><img id="statusReloadBtn" src="
#line 498 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "stop_update.png") );
  reply.out() << _tntChunks[136]; // " alt="" /></a>\n\t\t\t</div>\n\t\t\t<div id="infobox_recording_buttons" style="display: none">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 501 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq12;
#line 501 "pageelems.ecpp"
    _tnt_cq12.add( "action", ("stop_recording"));
#line 501 "pageelems.ecpp"
    _tnt_cq12.add( "id", ("infobox_stop"));
#line 501 "pageelems.ecpp"
    _tnt_cq12.add( "image", ("stop.png"));
#line 501 "pageelems.ecpp"
    _tnt_cq12.add( "tip", (tr("stop playback")));
#line 501 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq12);
    // &>
  }
  reply.out() << _tntChunks[137]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 502 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq13;
#line 502 "pageelems.ecpp"
    _tnt_cq13.add( "action", ("play_recording"));
#line 502 "pageelems.ecpp"
    _tnt_cq13.add( "id", ("infobox_play"));
#line 502 "pageelems.ecpp"
    _tnt_cq13.add( "image", ("play.png"));
#line 502 "pageelems.ecpp"
    _tnt_cq13.add( "tip", (tr("resume playback")));
#line 502 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq13);
    // &>
  }
  reply.out() << _tntChunks[138]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 503 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq14;
#line 503 "pageelems.ecpp"
    _tnt_cq14.add( "action", ("pause_recording"));
#line 503 "pageelems.ecpp"
    _tnt_cq14.add( "id", ("infobox_pause"));
#line 503 "pageelems.ecpp"
    _tnt_cq14.add( "image", ("pause.png"));
#line 503 "pageelems.ecpp"
    _tnt_cq14.add( "tip", (tr("pause playback")));
#line 503 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq14);
    // &>
  }
  reply.out() << _tntChunks[139]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 504 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq15;
#line 504 "pageelems.ecpp"
    _tnt_cq15.add( "action", ("rwd_recording"));
#line 504 "pageelems.ecpp"
    _tnt_cq15.add( "id", ("infobox_rwd"));
#line 504 "pageelems.ecpp"
    _tnt_cq15.add( "image", ("rwd.png"));
#line 504 "pageelems.ecpp"
    _tnt_cq15.add( "tip", (tr("fast rewind")));
#line 504 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq15);
    // &>
  }
  reply.out() << _tntChunks[140]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 505 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq16;
#line 505 "pageelems.ecpp"
    _tnt_cq16.add( "action", ("ffw_recording"));
#line 505 "pageelems.ecpp"
    _tnt_cq16.add( "id", ("infobox_ffw"));
#line 505 "pageelems.ecpp"
    _tnt_cq16.add( "image", ("ffw.png"));
#line 505 "pageelems.ecpp"
    _tnt_cq16.add( "tip", (tr("fast forward")));
#line 505 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq16);
    // &>
  }
  reply.out() << _tntChunks[141]; // \n\t\t\t</div>\n\t\t\t<div id="infobox_channel_buttons">\n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 508 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq17;
#line 508 "pageelems.ecpp"
    _tnt_cq17.add( "action", ("switch_channel"));
#line 508 "pageelems.ecpp"
    _tnt_cq17.add( "id", ("infobox_prevchan"));
#line 508 "pageelems.ecpp"
    _tnt_cq17.add( "image", ("one_downarrow.png"));
#line 508 "pageelems.ecpp"
    _tnt_cq17.add( "tip", (tr("previous channel")));
#line 508 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq17);
    // &>
  }
  reply.out() << _tntChunks[142]; // \n\t\t\t\t
  // <& ajax_action_href ...
  { 
#line 509 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq18;
#line 509 "pageelems.ecpp"
    _tnt_cq18.add( "action", ("switch_channel"));
#line 509 "pageelems.ecpp"
    _tnt_cq18.add( "id", ("infobox_nextchan"));
#line 509 "pageelems.ecpp"
    _tnt_cq18.add( "image", ("one_uparrow.png"));
#line 509 "pageelems.ecpp"
    _tnt_cq18.add( "tip", (tr("next channel")));
#line 509 "pageelems.ecpp"
  main().ajax_action_href(request, reply, _tnt_cq18);
    // &>
  }
  reply.out() << _tntChunks[143]; // \n\t\t\t</div>\n\t\t\t<div class="st_pbar">\n\t\t\t\t
  // <& progressbar ...
  { 
#line 512 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq19;
#line 512 "pageelems.ecpp"
    _tnt_cq19.add( "id", ("infobox_elapsed"));
#line 512 "pageelems.ecpp"
  main().progressbar(request, reply, _tnt_cq19);
    // &>
  }
  reply.out() << _tntChunks[144]; // \n\t\t\t</div>\n\t\t</div>\n\t</div>\n\t<div style="display: none;">\n\t\t<span id="__infobox_request_err">
#line 517 "pageelems.ecpp"
  reply.sout() << ( tr("No server response!") );
  reply.out() << _tntChunks[145]; // </span>\n\t\t<span id="__infobox_update_err">
#line 518 "pageelems.ecpp"
  reply.sout() << ( tr("Failed to update infobox!") );
  reply.out() << _tntChunks[146]; // </span>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tool_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tool_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
int detail = qparam.get< int >("detail");
std::string epgid = qparam.get< std::string >("epgid");
std::string title = qparam.get< std::string >("title");
time_t startTime = qparam.get< time_t >("startTime");
time_t endTime = qparam.get< time_t >("endTime");
int lastCurrentChanel = qparam.get< int >("lastCurrentChanel", ( int()));
std::string s_IMDB_ID = qparam.get< std::string >("s_IMDB_ID");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 535 "pageelems.ecpp"

	int duration = EpgEvents::Duration(startTime, endTime);
	int elapsed = EpgEvents::ElapsedTime(startTime, endTime);
  tEventID eventId = tEventID();
	tChannelID channelId = tChannelID();

	EpgEvents::DecodeDomId(epgid, channelId, eventId);
	if (detail) { // output for vertical toolbox

  reply.out() << _tntChunks[149]; // \t
  // <& pageelems.event_timer ...
  { 
#line 544 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq20;
#line 544 "pageelems.ecpp"
    _tnt_cq20.add( "epgid", (epgid));
#line 544 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq20);
    // &>
  }
  reply.out() << _tntChunks[150]; // \n
#line 545 "pageelems.ecpp"

  if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[151]; // \t  
  // <& pageelems.ajax_action_href ...
  { 
#line 548 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq21;
#line 548 "pageelems.ecpp"
    _tnt_cq21.add( "action", "switch_channel");
#line 548 "pageelems.ecpp"
    _tnt_cq21.add( "alt", "");
#line 548 "pageelems.ecpp"
    _tnt_cq21.add( "image", "zap.png");
#line 548 "pageelems.ecpp"
    _tnt_cq21.add( "param", (channelId));
#line 548 "pageelems.ecpp"
    _tnt_cq21.add( "tip", (tr("Switch to this channel.")));
#line 548 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq21);
    // &>
  }
  reply.out() << _tntChunks[152]; // \n
#line 549 "pageelems.ecpp"

	} if (LiveFeatures<features::epgsearch>().Recent() && eventId != 0) {

  reply.out() << _tntChunks[153]; // \t<a href="searchresults.html\?searchplain=
#line 552 "pageelems.ecpp"
  reply.sout() << ( StringEscapeAndBreak(title) );
  reply.out() << _tntChunks[154]; // "><img src="
#line 552 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[155]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 552 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq22;
#line 552 "pageelems.ecpp"
    _tnt_cq22.add( "text", (tr("Search for repeats.")));
#line 552 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq22);
    // &>
  }
  reply.out() << _tntChunks[156]; // ></img></a>\n
#line 553 "pageelems.ecpp"

		}
		if ((duration == 0) || (elapsed >= 0)) {

  reply.out() << _tntChunks[157]; // \t
  // <& pageelems.hls_channel ...
  { 
#line 557 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq23;
#line 557 "pageelems.ecpp"
    _tnt_cq23.add( "channelId", (channelId));
#line 557 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq23);
    // &>
  }
  reply.out() << _tntChunks[158]; // \n\t
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 558 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq24;
#line 558 "pageelems.ecpp"
    _tnt_cq24.add( "channelId", (channelId));
#line 558 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq24);
    // &>
  }
  reply.out() << _tntChunks[159]; // \n
#line 559 "pageelems.ecpp"

		}
	if (eventId != 0) {
    /* Need to lock here channels also, because CreateEpgInfo will lock
     * it also and this will result in a wrong lock order */
    LOCK_CHANNELS_READ;
    LOCK_SCHEDULES_READ;
    EpgInfoPtr epgEvent = EpgEvents::CreateEpgInfo(epgid, Schedules);
    const cEvent* event = epgEvent->Event();
    const cChannel* channel = event?Channels->GetByChannelID(event->ChannelID()):nullptr;
    cGetScraperVideo getScraperVideo(event, NULL);
    bool scraperDataAvailable = getScraperVideo.call(LiveSetup().GetPluginScraper());
    if (scraperDataAvailable) {
      int video_SD_HD = getScraperVideo.m_scraperVideo->getHD();
      char sdhd = video_SD_HD == 0 ? 's': video_SD_HD == 1 ? 'h': video_SD_HD == 2 ? 'u' : 0;


  reply.out() << _tntChunks[160]; // \t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 576 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq25;
#line 576 "pageelems.ecpp"
    _tnt_cq25.add( "s_IMDB_ID", (s_IMDB_ID));
#line 576 "pageelems.ecpp"
    _tnt_cq25.add( "title", (title));
#line 576 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq25);
    // &>
  }
  reply.out() << _tntChunks[161]; // \n
#line 577 "pageelems.ecpp"
 if (detail > 1) {

  reply.out() << _tntChunks[162]; // <img data-src="img/transparent.png" height="10px" />\n<span id="icons-
#line 579 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[163]; // "></span>\n
  reply.out() << _tntChunks[164]; // \n
#line 583 "pageelems.ecpp"
 if (sdhd) { 
  reply.out() << _tntChunks[165]; // \t\t\t\t\t<script class="injectIcons">\n\t\t\t\t\tinjectHdSdIcon("icons-
#line 585 "pageelems.ecpp"
  reply.sout() << (epgid);
  reply.out() << _tntChunks[166]; // ", "
#line 585 "pageelems.ecpp"
  reply.sout() << (sdhd);
  reply.out() << _tntChunks[167]; // ", "
#line 585 "pageelems.ecpp"
  reply.sout() << ((channel&&channel->Name())?channel->Name():"");
  reply.out() << _tntChunks[168]; // ")\n\t\t\t\t\t</script>\n
#line 587 "pageelems.ecpp"

				}
		  }
		}
		}
	}
	else { // table output

  reply.out() << _tntChunks[169]; // \t\t<td class="action leftcol 
#line 595 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[170]; // ">
  // <& pageelems.event_timer ...
  { 
#line 595 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq26;
#line 595 "pageelems.ecpp"
    _tnt_cq26.add( "epgid", (epgid));
#line 595 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "event_timer"), request, reply, _tnt_cq26);
    // &>
  }
  reply.out() << _tntChunks[171]; // </td>\n
#line 596 "pageelems.ecpp"

    if (cDevice::PrimaryDevice() && cDevice::PrimaryDevice()->HasDecoder() ) {

  reply.out() << _tntChunks[172]; // \t\t<td class="action 
#line 599 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[173]; // ">
  // <& pageelems.ajax_action_href ...
  { 
#line 599 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq27;
#line 599 "pageelems.ecpp"
    _tnt_cq27.add( "action", "switch_channel");
#line 599 "pageelems.ecpp"
    _tnt_cq27.add( "alt", "");
#line 599 "pageelems.ecpp"
    _tnt_cq27.add( "image", "zap.png");
#line 599 "pageelems.ecpp"
    _tnt_cq27.add( "param", (channelId));
#line 599 "pageelems.ecpp"
    _tnt_cq27.add( "tip", (tr("Switch to this channel.")));
#line 599 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "ajax_action_href"), request, reply, _tnt_cq27);
    // &>
  }
  reply.out() << _tntChunks[174]; // </td>\n\t\t
#line 600 "pageelems.ecpp"
 } if (LiveFeatures<features::epgsearch>().Recent()) { 
  reply.out() << _tntChunks[175]; // \t\t<td class="action 
#line 601 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[176]; // ">\n\t\t\t
#line 602 "pageelems.ecpp"
 if (eventId) { 
  reply.out() << _tntChunks[177]; // \t\t\t<a href="searchresults.html\?searchplain=
#line 603 "pageelems.ecpp"
  reply.sout() << ( StringUrlEncode(title) );
  reply.out() << _tntChunks[178]; // "><img src="
#line 603 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", "search.png") );
  reply.out() << _tntChunks[179]; // " alt="" 
  // <& tooltip.hint ...
  { 
#line 603 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq28;
#line 603 "pageelems.ecpp"
    _tnt_cq28.add( "text", (tr("Search for repeats.")));
#line 603 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "tooltip", "hint"), request, reply, _tnt_cq28);
    // &>
  }
  reply.out() << _tntChunks[180]; // ></img></a></td>\n\t\t
#line 604 "pageelems.ecpp"
 } } 
  reply.out() << _tntChunks[181]; // \t\t<td class="action 
#line 605 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[182]; // ">
#line 605 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.hls_channel ...
  { 
#line 605 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq29;
#line 605 "pageelems.ecpp"
    _tnt_cq29.add( "channelId", (channelId));
#line 605 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "hls_channel"), request, reply, _tnt_cq29);
    // &>
  }
#line 605 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[183]; // </td>\n\t\t
#line 606 "pageelems.ecpp"
 if (LiveSetup().GetShowPlayMediaplayer() ) { 
  reply.out() << _tntChunks[184]; // \t\t<td class="action 
#line 607 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[185]; // ">
#line 607 "pageelems.ecpp"
if ((duration == 0) || (elapsed > 0)) { 
  // <& pageelems.m3u_playlist_channel ...
  { 
#line 607 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq30;
#line 607 "pageelems.ecpp"
    _tnt_cq30.add( "channelId", (channelId));
#line 607 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "m3u_playlist_channel"), request, reply, _tnt_cq30);
    // &>
  }
#line 607 "pageelems.ecpp"
 } 
  reply.out() << _tntChunks[186]; // </td>\n\t\t
#line 608 "pageelems.ecpp"
 } if (LiveSetup().GetShowIMDb() ) { 
  reply.out() << _tntChunks[187]; // \t\t<td class="action 
#line 609 "pageelems.ecpp"
  if ( lastCurrentChanel )
    reply.sout() <<  "bottomrow";
  reply.out() << _tntChunks[188]; // ">\n
#line 610 "pageelems.ecpp"

			if (eventId != 0) {

  reply.out() << _tntChunks[189]; // \t\t\t
  // <& pageelems.imdb_info_href ...
  { 
#line 613 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq31;
#line 613 "pageelems.ecpp"
    _tnt_cq31.add( "s_IMDB_ID", (s_IMDB_ID));
#line 613 "pageelems.ecpp"
    _tnt_cq31.add( "title", (title));
#line 613 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "imdb_info_href"), request, reply, _tnt_cq31);
    // &>
  }
  reply.out() << _tntChunks[190]; // \n
#line 614 "pageelems.ecpp"

			}

  reply.out() << _tntChunks[191]; // \t\t</td>\n
#line 618 "pageelems.ecpp"

	} }

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::epg_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::epg_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
std::string boxId = qparam.get< std::string >("boxId");
std::string caption = qparam.get< std::string >("caption");
std::string tools_comp = qparam.get< std::string >("tools_comp");
std::string time = qparam.get< std::string >("time");
std::string channel = qparam.get< std::string >("channel");
std::string title = qparam.get< std::string >("title");
std::string short_descr = qparam.get< std::string >("short_descr");
std::string long_descr = qparam.get< std::string >("long_descr");
std::string filename = qparam.get< std::string >("filename");
std::string archived = qparam.get< std::string >("archived");
std::string epgImage = qparam.get< std::string >("epgImage");
uintptr_t ievent = qparam.get< uintptr_t >("ievent");
uintptr_t irecording = qparam.get< uintptr_t >("irecording");
uintptr_t iepgEvent = qparam.get< uintptr_t >("iepgEvent");
int elapsed = qparam.get< int >("elapsed", ( -1));
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[194]; // \t<div class="epg_description" id="
#line 643 "pageelems.ecpp"
  reply.sout() << ( (boxId) );
  reply.out() << _tntChunks[195]; // ">\n\t\t<div class="station">\n\t\t\t<div class="boxheader">\n\n<div>\n
#line 648 "pageelems.ecpp"

struct sEpisode2 {
    int number;
    int season;
    int absoluteNumber;
    std::string name;
    std::string firstAired;
    int runtime;
    std::string overview;
    float vote_average;
    int vote_count;
    cTvMedia episodeImage;
    std::string IMDB_ID;
};
struct sScraperMovieOrTv {
    bool found;
    bool movie;
    std::string title;
    std::string originalTitle;
    std::string tagline;
    std::string overview;
    std::vector<std::string> genres;
    std::string homepage;
    std::string releaseDate;  // for TV shows: firstAired
    bool adult;
    int runtime;
    float popularity;
    float voteAverage;
    int voteCount;
    std::vector<std::string> productionCountries;
    std::string IMDB_ID;
    std::vector<cTvMedia> posters;
    std::vector<cTvMedia> banners;
    std::vector<cTvMedia> fanarts;
// only for movies
    int budget;
    int revenue;
    int collectionId;
    std::string collectionName;
// only for TV Shows
    std::string status;
    std::vector<std::string> networks;
    int lastSeason;
// episode related
    bool episodeFound;
    cTvMedia seasonPoster;
    sEpisode2 episode;
};

EpgInfoPtr epgEvent;
if (iepgEvent) epgEvent = *static_cast<EpgInfoPtr*>((void *)iepgEvent);


sScraperMovieOrTv scraperMovieOrTv;
cGetScraperVideo getScraperVideo(static_cast<cEvent *>((void *)ievent), static_cast<cRecording *>((void *)irecording));
scraperMovieOrTv.found = getScraperVideo.call(LiveSetup().GetPluginScraper());
if (scraperMovieOrTv.found) {
  tvType type = getScraperVideo.m_scraperVideo->getVideoType();
//  esyslog("live: type = %i", (int)type);
  if (type == tMovie) scraperMovieOrTv.movie = true;
  else {
    if (type == tSeries) scraperMovieOrTv.movie = false;
    else scraperMovieOrTv.found = false;
  }
}
if (scraperMovieOrTv.found) {
  scraperMovieOrTv.found = getScraperVideo.m_scraperVideo->getMovieOrTv(&scraperMovieOrTv.title, &scraperMovieOrTv.originalTitle, &scraperMovieOrTv.tagline, &scraperMovieOrTv.overview, &scraperMovieOrTv.genres, &scraperMovieOrTv.homepage, &scraperMovieOrTv.releaseDate, &scraperMovieOrTv.adult, &scraperMovieOrTv.runtime, &scraperMovieOrTv.popularity, &scraperMovieOrTv.voteAverage, &scraperMovieOrTv.voteCount, &scraperMovieOrTv.productionCountries, &scraperMovieOrTv.IMDB_ID, &scraperMovieOrTv.budget, &scraperMovieOrTv.revenue, &scraperMovieOrTv.collectionId, &scraperMovieOrTv.collectionName, &scraperMovieOrTv.status, &scraperMovieOrTv.networks, &scraperMovieOrTv.lastSeason);
}
std::vector<std::unique_ptr<cCharacter>> scraperCharacters;
if (scraperMovieOrTv.found) {
  scraperCharacters = getScraperVideo.m_scraperVideo->getCharacters(false);
  scraperMovieOrTv.posters = getScraperVideo.m_scraperVideo->getImages(eOrientation::portrait, 3, false);
  scraperMovieOrTv.banners = getScraperVideo.m_scraperVideo->getImages(eOrientation::banner, 3, false);
  scraperMovieOrTv.fanarts = getScraperVideo.m_scraperVideo->getImages(eOrientation::landscape, 3, false);
  scraperMovieOrTv.episodeFound = getScraperVideo.m_scraperVideo->getEpisode(&scraperMovieOrTv.episode.name, &scraperMovieOrTv.episode.overview, &scraperMovieOrTv.episode.absoluteNumber, &scraperMovieOrTv.episode.firstAired, &scraperMovieOrTv.episode.runtime, &scraperMovieOrTv.episode.vote_average, &scraperMovieOrTv.episode.vote_count, &scraperMovieOrTv.episode.IMDB_ID);
  if (scraperMovieOrTv.episodeFound) {
    scraperMovieOrTv.episode.number = getScraperVideo.m_scraperVideo->getEpisodeNumber();
    scraperMovieOrTv.episode.season = getScraperVideo.m_scraperVideo->getSeasonNumber();
    scraperMovieOrTv.episode.episodeImage = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::episodeMovie), cOrientations(eOrientation::landscape), false);
    scraperMovieOrTv.seasonPoster = getScraperVideo.m_scraperVideo->getImage(cImageLevels(eImageLevel::seasonMovie), cOrientations(eOrientation::portrait), false);
  }
}

const bool episodeFound = scraperMovieOrTv.found && (!scraperMovieOrTv.movie) && scraperMovieOrTv.episodeFound;
if (scraperMovieOrTv.found) {
//  esyslog("live: create caption menu");

  reply.out() << _tntChunks[196]; // <div class = "caption menu">\n  <a id="
#line 736 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[197]; // _epg_m"     class = "active"   onclick="displayEPG('
#line 736 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[198]; // ')" >
#line 736 "pageelems.ecpp"
  reply.sout() << ( trVDR("EPG") );
  reply.out() << _tntChunks[199]; // </a>\n| <a id="
#line 737 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[200]; // _scraper_m" class = "inactive" onclick="displayScraper('
#line 737 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[201]; // ')">
#line 737 "pageelems.ecpp"
  reply.sout() << ( tr("Scraper") );
  reply.out() << _tntChunks[202]; // </a>\n| <a id="
#line 738 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[203]; // _actors_m"  class = "inactive" onclick="displayActors('
#line 738 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[204]; // ')" >
#line 738 "pageelems.ecpp"
  reply.sout() << ( tr("Actors") );
  reply.out() << _tntChunks[205]; // </a>\n| <a id="
#line 739 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[206]; // _artwork_m" class = "inactive" onclick="displayArtwork('
#line 739 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[207]; // ')" >
#line 739 "pageelems.ecpp"
  reply.sout() << ( tr("Artwork") );
  reply.out() << _tntChunks[208]; // </a>\n</div>\n
#line 741 "pageelems.ecpp"

} else {

  reply.out() << _tntChunks[209]; // <div class="caption">
#line 744 "pageelems.ecpp"
  reply.sout() << ( (caption) );
  reply.out() << _tntChunks[210]; // </div>\n
#line 745 "pageelems.ecpp"

}

  reply.out() << _tntChunks[211]; // </div>\n                        </div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div class="epg_tools">\n\t\t\t\t
  // <& (tools_comp) ...
  { 
#line 753 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq32;
#line 753 "pageelems.ecpp"
    _tnt_cq32.add( "archived", (archived));
#line 753 "pageelems.ecpp"
    _tnt_cq32.add( "detail", (2));
#line 753 "pageelems.ecpp"
    _tnt_cq32.add( "id", (boxId));
#line 753 "pageelems.ecpp"
    _tnt_cq32.add( "s_IMDB_ID", (scraperMovieOrTv.IMDB_ID));
#line 753 "pageelems.ecpp"
    _tnt_cq32.add( "title", (title));
#line 753 "pageelems.ecpp"
    callComp((tools_comp), request, reply, _tnt_cq32);
    // &>
  }
  reply.out() << _tntChunks[212]; // \n\t\t\t</div>\n\t\t\t<div class="epg_info">\n\t\t\t\t<div class="info">\n\t\t\t\t\t<div class="duration">\n
#line 758 "pageelems.ecpp"

if (epgEvent && epgEvent->EventDuration() >= 0) {  // recording

  reply.out() << _tntChunks[213]; // \t\t\t\t\t\t<span title="
#line 761 "pageelems.ecpp"
  reply.sout() << (tr("Recording length"));
  reply.out() << _tntChunks[214]; // ">
#line 761 "pageelems.ecpp"
  reply.sout() << ( FormatDuration(tr("%d:%02d"), epgEvent->Duration()));
  reply.out() << _tntChunks[215]; // </span> / <span title="
#line 761 "pageelems.ecpp"
  reply.sout() << (tr("Event duration"));
  reply.out() << _tntChunks[216]; // ">
#line 761 "pageelems.ecpp"
  reply.sout() << (FormatDuration(tr("%d:%02d"), epgEvent->EventDuration()));
  reply.out() << _tntChunks[217]; // </span>\n
#line 762 "pageelems.ecpp"

}
if (elapsed >= 0) {

  reply.out() << _tntChunks[218]; // \t\t\t\t\t\t<div class="progress"><div>
  // <& pageelems.progressbar ...
  { 
#line 766 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq33;
#line 766 "pageelems.ecpp"
    _tnt_cq33.add( "progress", (elapsed));
#line 766 "pageelems.ecpp"
    callComp(tnt::Subcompident(std::string(), "pageelems", "progressbar"), request, reply, _tnt_cq33);
    // &>
  }
  reply.out() << _tntChunks[219]; // </div></div>\n
#line 767 "pageelems.ecpp"

}

  reply.out() << _tntChunks[220]; // \t\t\t\t\t</div>\n\t\t\t\t\t<div class="time">\n
#line 772 "pageelems.ecpp"
           if (!archived.empty()) {

  reply.out() << _tntChunks[221]; //               <span class="bold">
#line 773 "pageelems.ecpp"
  reply.sout() << ( (archived + " ") );
  reply.out() << _tntChunks[222]; // </span>\n
#line 774 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[223]; //             
#line 775 "pageelems.ecpp"
  reply.sout() << ( (time) );
  reply.out() << _tntChunks[224]; // \n
#line 776 "pageelems.ecpp"
           if (!filename.empty() && !channel.empty()) {

  reply.out() << _tntChunks[225]; //               <div class="channel">
#line 777 "pageelems.ecpp"
  reply.sout() << ( (channel) );
  reply.out() << _tntChunks[226]; // </div>\n
#line 778 "pageelems.ecpp"
           }

  reply.out() << _tntChunks[227]; // \t\t\t\t\t</div>\n\t\t\t\t\t<div class="title">
#line 780 "pageelems.ecpp"
  reply.sout() << ( (title) );
  reply.out() << _tntChunks[228]; // </div>\n\t\t\t\t\t<div class="short">
#line 781 "pageelems.ecpp"
  reply.sout() << ( (short_descr) );
  reply.out() << _tntChunks[229]; // </div>\n\t\t\t\t\t<div class="description" id=
#line 782 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[230]; // _description>\n\t\t\t\t\t<span id = "
#line 783 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[231]; // _epg_image" class="epg_images">\n
#line 784 "pageelems.ecpp"

	std::list<std::string> images = EpgEvents::EpgImages(boxId);
	for(std::list<std::string>::iterator it = images.begin(); it != images.end(); ++it ) {

  reply.out() << _tntChunks[232]; //          <a href="/epgimages/
#line 788 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[233]; // " target="_blank">\n\t\t\t\t\t\t<img src="/epgimages/
#line 789 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[234]; // " class="epg_image"/>\n         </a>\n
#line 791 "pageelems.ecpp"

	}
	if(!epgImage.empty() ) {

  reply.out() << _tntChunks[235]; //     <a href="/tvscraper/
#line 795 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[236]; // " target="_blank">\n\t    <img src="/tvscraper/
#line 796 "pageelems.ecpp"
  reply.sout() << ( epgImage );
  reply.out() << _tntChunks[237]; // " class="epg_image"/>\n    </a>\n
#line 798 "pageelems.ecpp"
   if (episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty() ) {

  reply.out() << _tntChunks[238]; //       <a href="/tvscraper/
#line 799 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[239]; // " target="_blank">\n        <img src="/tvscraper/
#line 800 "pageelems.ecpp"
  reply.sout() << ( scraperMovieOrTv.episode.episodeImage.path );
  reply.out() << _tntChunks[240]; // " class="epg_image"/>\n      </a>\n
#line 802 "pageelems.ecpp"

    }  // episodeFound && !scraperMovieOrTv.episode.episodeImage.path.empty()
	} else {
    std::list<std::string> images1 = EpgEvents::RecImages(boxId, filename);
    size_t delimPos = boxId.find_last_of('_');
    std::string recId = (delimPos)?boxId.substr(delimPos+1):boxId;

    for(std::list<std::string>::iterator it = images1.begin(); it != images1.end(); ++it ) {

  reply.out() << _tntChunks[241]; //       <a href="/recimages/
#line 811 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[242]; // /
#line 811 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[243]; // " target="_blank">\n\t\t\t\t<img src="/recimages/
#line 812 "pageelems.ecpp"
  reply.sout() << ( recId );
  reply.out() << _tntChunks[244]; // /
#line 812 "pageelems.ecpp"
  reply.sout() << ( *it );
  reply.out() << _tntChunks[245]; // " class="epg_image"/>\n      </a>\n
#line 814 "pageelems.ecpp"

    }
  }

  reply.out() << _tntChunks[246]; // \t\t\t\t\t</span> 
  reply.out() << _tntChunks[247]; // \n\n
  reply.out() << _tntChunks[248]; // \n<div id = '
#line 821 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[249]; // _scraper' hidden>\n
#line 822 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[250]; //   <div class="scraper_list">
#line 825 "pageelems.ecpp"
  reply.sout() << ( tr("Title:") );
  reply.out() << _tntChunks[251]; //          
#line 825 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.title ) );
  reply.out() << _tntChunks[252]; // </div>\n
#line 826 "pageelems.ecpp"

  if (!scraperMovieOrTv.originalTitle.empty() ) {

  reply.out() << _tntChunks[253]; //   <div class="scraper_list">
#line 829 "pageelems.ecpp"
  reply.sout() << ( tr("Original title:") );
  reply.out() << _tntChunks[254]; //  
#line 829 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.originalTitle ) );
  reply.out() << _tntChunks[255]; // </div>\n
#line 830 "pageelems.ecpp"

  }
  if (episodeFound) {

  reply.out() << _tntChunks[256]; //     <div class="scraper_list">
#line 834 "pageelems.ecpp"
  reply.sout() << ( tr("Episode:") );
  reply.out() << _tntChunks[257]; //  S
#line 834 "pageelems.ecpp"
  reply.sout() << ( std::to_string(scraperMovieOrTv.episode.season ) );
  reply.out() << _tntChunks[258]; // E
#line 834 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.number ) );
#line 834 "pageelems.ecpp"
  reply.sout() << (scraperMovieOrTv.episode.absoluteNumber?"A" + std::to_string(scraperMovieOrTv.episode.absoluteNumber):"");
  reply.out() << _tntChunks[259]; //  
#line 834 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.name ) );
  reply.out() << _tntChunks[260]; // </div>\n    <div class="scraper_list">
#line 835 "pageelems.ecpp"
  reply.sout() << ( tr("Episode overview:") );
  reply.out() << _tntChunks[261]; //    
#line 835 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.overview ) );
  reply.out() << _tntChunks[262]; // </div>\n
#line 836 "pageelems.ecpp"

    if (scraperMovieOrTv.episode.vote_average != 0 ) {

  reply.out() << _tntChunks[263]; //       <div class="scraper_list">
#line 839 "pageelems.ecpp"
  reply.sout() << ( tr("Episode vote average/count:") );
  reply.out() << _tntChunks[264]; //  
#line 839 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_average ) );
  reply.out() << _tntChunks[265]; //  / 
#line 839 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.vote_count ) );
  reply.out() << _tntChunks[266]; // </div>\n
#line 840 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[267]; //     <div class="scraper_list">
#line 843 "pageelems.ecpp"
  reply.sout() << ( tr("Episode first aired:") );
  reply.out() << _tntChunks[268]; //  
#line 843 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.firstAired ) );
  reply.out() << _tntChunks[269]; // </div>\n
#line 844 "pageelems.ecpp"
   if (scraperMovieOrTv.episode.runtime > 0) {

  reply.out() << _tntChunks[270]; //       <div class="scraper_list">
#line 845 "pageelems.ecpp"
  reply.sout() << ( tr("Episode runtime:") );
  reply.out() << _tntChunks[271]; //  
#line 845 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.runtime ) );
  reply.out() << _tntChunks[272]; // </div>\n
#line 846 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[273]; // \n
#line 850 "pageelems.ecpp"
   if (!scraperMovieOrTv.episode.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[274]; //       <a href="https://www.imdb.com/title/
#line 851 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.episode.IMDB_ID ) );
  reply.out() << _tntChunks[275]; // " target="_blank"> 
#line 851 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB episode") );
  reply.out() << _tntChunks[276]; //  </a>\n
#line 852 "pageelems.ecpp"

    }
    bool charFound = false;
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::guestStar ||
          character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
    if (charFound) {

  reply.out() << _tntChunks[277]; //       <div class="scraper_list">
#line 861 "pageelems.ecpp"
  reply.sout() << ( tr("Guest stars and crew") );
  reply.out() << _tntChunks[278]; // </div>\n      <table>\n
#line 863 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 864 "pageelems.ecpp"
     if (character->getType() != eCharacterType::guestStar) continue;

  reply.out() << _tntChunks[279]; //       <tr>\n        <td class="cast_role"> 
#line 866 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[280]; //  </td>\n        <td> 
#line 867 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[281]; //  </td>\n      </tr>\n
#line 869 "pageelems.ecpp"
   }

#line 870 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 871 "pageelems.ecpp"
     if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[282]; //       <tr>\n        <td class="cast_role"> 
#line 873 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[283]; //  </td>\n        <td> 
#line 874 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[284]; //  </td>\n      </tr>\n
#line 876 "pageelems.ecpp"
   }

#line 877 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 878 "pageelems.ecpp"
     if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[285]; //       <tr>\n        <td class="cast_role"> 
#line 880 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[286]; //  </td>\n        <td> 
#line 881 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[287]; //  </td>\n      </tr>\n
#line 883 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[288]; //       </table>\n
#line 885 "pageelems.ecpp"

    }  // end if !episode.<Guest stars and crew>.empty()
  }  // end if episode found
  if (!scraperMovieOrTv.tagline.empty() ) {

  reply.out() << _tntChunks[289]; //   <div class="scraper_list">
#line 890 "pageelems.ecpp"
  reply.sout() << ( tr("Tagline:") );
  reply.out() << _tntChunks[290]; //         
#line 890 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.tagline ) );
  reply.out() << _tntChunks[291]; // </div>\n
#line 891 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[292]; //   <div class="scraper_list">
#line 894 "pageelems.ecpp"
  reply.sout() << ( tr("Overview:") );
  reply.out() << _tntChunks[293]; //        
#line 894 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.overview ) );
  reply.out() << _tntChunks[294]; // </div>\n  <div class="scraper_list">
#line 895 "pageelems.ecpp"
  reply.sout() << ( tr("Genres:") );
  reply.out() << _tntChunks[295]; //          
#line 895 "pageelems.ecpp"
  reply.sout() << ( toString(scraperMovieOrTv.genres ) );
  reply.out() << _tntChunks[296]; // </div>\n
#line 896 "pageelems.ecpp"

  if (!scraperMovieOrTv.homepage.empty() ) {

  reply.out() << _tntChunks[297]; //   <div class="scraper_list"><a href ="
#line 899 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.homepage) );
  reply.out() << _tntChunks[298]; // " target="_blank">
#line 899 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[299]; // </a></div>\n
#line 900 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[300]; //   <div class="scraper_list">
#line 903 "pageelems.ecpp"
  reply.sout() << ( tr("Release date:") );
  reply.out() << _tntChunks[301]; //    
#line 903 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.releaseDate ) );
  reply.out() << _tntChunks[302]; // </div>\n
#line 904 "pageelems.ecpp"
 if (scraperMovieOrTv.runtime > 0) {

  reply.out() << _tntChunks[303]; //   <div class="scraper_list">
#line 905 "pageelems.ecpp"
  reply.sout() << ( tr("Runtime:") );
  reply.out() << _tntChunks[304]; //         
#line 905 "pageelems.ecpp"
  reply.sout() << ( std::to_string(scraperMovieOrTv.runtime) );
  reply.out() << _tntChunks[305]; // </div>\n
#line 906 "pageelems.ecpp"
 }

#line 907 "pageelems.ecpp"

  if (scraperMovieOrTv.popularity != 0) {

  reply.out() << _tntChunks[306]; //   <div class="scraper_list">
#line 910 "pageelems.ecpp"
  reply.sout() << ( tr("Popularity:") );
  reply.out() << _tntChunks[307]; //      
#line 910 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.popularity ) );
  reply.out() << _tntChunks[308]; // </div>\n
#line 911 "pageelems.ecpp"

  }
  if (scraperMovieOrTv.voteAverage  != 0) {

  reply.out() << _tntChunks[309]; //   <div class="scraper_list">
#line 915 "pageelems.ecpp"
  reply.sout() << ( tr("Vote average/count:") );
  reply.out() << _tntChunks[310]; //  
#line 915 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteAverage ) );
  reply.out() << _tntChunks[311]; //  / 
#line 915 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.voteCount ) );
  reply.out() << _tntChunks[312]; // </div>\n
#line 916 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[313]; // \n
#line 922 "pageelems.ecpp"
 if (!scraperMovieOrTv.IMDB_ID.empty() ) {

  reply.out() << _tntChunks[314]; //     <div class="scraper_list">\n      <a href="https://www.imdb.com/title/
#line 924 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.IMDB_ID ) );
  reply.out() << _tntChunks[315]; // " target="_blank"> 
#line 924 "pageelems.ecpp"
  reply.sout() << ( tr("IMDB") );
  reply.out() << _tntChunks[316]; //  </a>\n    </div>\n
#line 926 "pageelems.ecpp"
 }

  reply.out() << _tntChunks[317]; // \n
#line 931 "pageelems.ecpp"

  if (scraperMovieOrTv.movie) {
    if (scraperMovieOrTv.budget) {

  reply.out() << _tntChunks[318]; //     <div class="scraper_list">
#line 935 "pageelems.ecpp"
  reply.sout() << ( tr("Budget:") );
  reply.out() << _tntChunks[319]; //          
#line 935 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.budget ) );
  reply.out() << _tntChunks[320]; // </div>\n
#line 936 "pageelems.ecpp"

    }
    if (scraperMovieOrTv.revenue) {

  reply.out() << _tntChunks[321]; //     <div class="scraper_list">
#line 940 "pageelems.ecpp"
  reply.sout() << ( tr("Revenue:") );
  reply.out() << _tntChunks[322]; //         
#line 940 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.revenue) );
  reply.out() << _tntChunks[323]; // </div>\n
#line 941 "pageelems.ecpp"

    }

  reply.out() << _tntChunks[324]; // \n
#line 947 "pageelems.ecpp"

    if (!scraperMovieOrTv.collectionName.empty() ) {

  reply.out() << _tntChunks[325]; //     <div class="scraper_list">
#line 950 "pageelems.ecpp"
  reply.sout() << ( tr("Collection name:") );
  reply.out() << _tntChunks[326]; //  
#line 950 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.collectionName) );
  reply.out() << _tntChunks[327]; // </div>\n
#line 951 "pageelems.ecpp"

    }
  } else {  // TV show

  reply.out() << _tntChunks[328]; //     <div class="scraper_list">
#line 955 "pageelems.ecpp"
  reply.sout() << ( tr("Status:") );
  reply.out() << _tntChunks[329]; //          
#line 955 "pageelems.ecpp"
  reply.sout() << ( (scraperMovieOrTv.status    ) );
  reply.out() << _tntChunks[330]; // </div>\n
  reply.out() << _tntChunks[331]; // \n
#line 959 "pageelems.ecpp"

  }
  bool charFound = false;
  for (const auto &character:scraperCharacters)
    if (character->getType() == eCharacterType::actor) { charFound = true; break; }
  if (!charFound && scraperMovieOrTv.movie) {
    for (const auto &character:scraperCharacters)
      if (character->getType() == eCharacterType::writer ||
          character->getType() == eCharacterType::director) { charFound = true; break; }
  }
  if (charFound) {

  reply.out() << _tntChunks[332]; //     <div class="scraper_list">
#line 971 "pageelems.ecpp"
  reply.sout() << ( tr("Cast and crew") );
  reply.out() << _tntChunks[333]; // </div>\n    <table>\n
#line 973 "pageelems.ecpp"
   for (const auto &character:scraperCharacters) {

#line 974 "pageelems.ecpp"
     if (character->getType() != eCharacterType::actor) continue;

  reply.out() << _tntChunks[334]; //       <tr>\n        <td class="cast_role"> 
#line 976 "pageelems.ecpp"
  reply.sout() << ( character->getCharacterName() );
  reply.out() << _tntChunks[335]; //  </td>\n        <td> 
#line 977 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[336]; //  </td>\n      </tr>\n
#line 979 "pageelems.ecpp"
   }

#line 980 "pageelems.ecpp"
   if (scraperMovieOrTv.movie) {

#line 981 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 982 "pageelems.ecpp"
       if (character->getType() != eCharacterType::writer) continue;

  reply.out() << _tntChunks[337]; //         <tr>\n          <td class="cast_role"> 
#line 984 "pageelems.ecpp"
  reply.sout() << ( tr("Writer") );
  reply.out() << _tntChunks[338]; //  </td>\n          <td> 
#line 985 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[339]; //  </td>\n        </tr>\n
#line 987 "pageelems.ecpp"
     }

#line 988 "pageelems.ecpp"
     for (const auto &character:scraperCharacters) {

#line 989 "pageelems.ecpp"
       if (character->getType() != eCharacterType::director) continue;

  reply.out() << _tntChunks[340]; //         <tr>\n          <td class="cast_role"> 
#line 991 "pageelems.ecpp"
  reply.sout() << ( tr("Director") );
  reply.out() << _tntChunks[341]; //  </td>\n          <td> 
#line 992 "pageelems.ecpp"
  reply.sout() << ( character->getPersonName() );
  reply.out() << _tntChunks[342]; //  </td>\n        </tr>\n
#line 994 "pageelems.ecpp"
     }

#line 995 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[343]; //   </table>\n
#line 997 "pageelems.ecpp"

  }
}

  reply.out() << _tntChunks[344]; // </div>\n
  reply.out() << _tntChunks[345]; // \n<div id = '
#line 1003 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[346]; // _actors' hidden>\n
#line 1004 "pageelems.ecpp"

if (scraperMovieOrTv.found) {

  reply.out() << _tntChunks[347]; // <table>\n
#line 1008 "pageelems.ecpp"

  const int num_cols = 4;
  int num = 1;
  std::string actor_names = "";

  for (const auto &character:scraperCharacters) {
    if (character->getImage().path.empty() ) continue;  // only actors with images
    if (num == 1) {

  reply.out() << _tntChunks[348]; //       <tr>\n
#line 1018 "pageelems.ecpp"
   }

  reply.out() << _tntChunks[349]; //     <td>\n      <a href="/tvscraper/
#line 1020 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[350]; // " target="_blank">\n        <img src="/tvscraper/
#line 1021 "pageelems.ecpp"
  reply.sout() << ( character->getImage().path );
  reply.out() << _tntChunks[351]; // " alt="
#line 1021 "pageelems.ecpp"
  reply.sout() << (character->getPersonName());
  reply.out() << _tntChunks[352]; // : 
#line 1021 "pageelems.ecpp"
  reply.sout() << (character->getCharacterName());
  reply.out() << _tntChunks[353]; // " class="actor">\n        </img>\n      </a>\n    </td>\n
#line 1025 "pageelems.ecpp"

    actor_names.append("<td>"); 
    actor_names.append(character->getPersonName()); 
    actor_names.append(":<br>"); 
    actor_names.append(character->getCharacterName()); 
    actor_names.append("</td>"); 
    if (num == num_cols) {

  reply.out() << _tntChunks[354]; //       </tr>\n      <tr>
#line 1034 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[355]; // </tr>\n
#line 1035 "pageelems.ecpp"

      num = 0;
      actor_names = "";
    }
    num++;
  } // for character in scraperCharacters
  if (num != 1) {

  reply.out() << _tntChunks[356]; //     </tr>\n    <tr>
#line 1044 "pageelems.ecpp"
  reply.out() << (actor_names);
  reply.out() << _tntChunks[357]; // </tr>\n
#line 1045 "pageelems.ecpp"

  }

  reply.out() << _tntChunks[358]; // </table>\n
#line 1049 "pageelems.ecpp"

}

  reply.out() << _tntChunks[359]; // </div>\n
  reply.out() << _tntChunks[360]; // \n<div id = '
#line 1054 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[361]; // _artwork' hidden>\n
#line 1055 "pageelems.ecpp"

  const uintptr_t media_p = (uintptr_t)&(scraperMovieOrTv.posters);
  const uintptr_t media_b = (uintptr_t)&(scraperMovieOrTv.banners);
  const uintptr_t media_f = (uintptr_t)&(scraperMovieOrTv.fanarts);

  // <& media ...
  { 
#line 1060 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq34;
#line 1060 "pageelems.ecpp"
    _tnt_cq34.add( "media_p", (media_p));
#line 1060 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq34);
    // &>
  }
  reply.out() << _tntChunks[362]; // \n
  // <& media ...
  { 
#line 1061 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq35;
#line 1061 "pageelems.ecpp"
    _tnt_cq35.add( "media_p", (media_f));
#line 1061 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq35);
    // &>
  }
  reply.out() << _tntChunks[363]; // \n
  // <& media ...
  { 
#line 1062 "pageelems.ecpp"
    tnt::QueryParams _tnt_cq36;
#line 1062 "pageelems.ecpp"
    _tnt_cq36.add( "media_p", (media_b));
#line 1062 "pageelems.ecpp"
  main().media(request, reply, _tnt_cq36);
    // &>
  }
  reply.out() << _tntChunks[364]; // \n</div>\n
  reply.out() << _tntChunks[365]; // \n<div id = '
#line 1065 "pageelems.ecpp"
  reply.sout() << ( boxId );
  reply.out() << _tntChunks[366]; // _epg'>\n\t\t\t\t\t
#line 1066 "pageelems.ecpp"
 reply.out() << StringEscapeAndBreak(long_descr); 
  reply.out() << _tntChunks[367]; // \t\t\t\t</div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n</div>\n
  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::media_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::media " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
  // <%args>
uintptr_t media_p = qparam.get< uintptr_t >("media_p");
  // </%args>

#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
#line 1079 "pageelems.ecpp"

const std::vector<cTvMedia> *media_v = static_cast<std::vector<cTvMedia> *>((void *)media_p);
for (const cTvMedia &media: *media_v) {

  reply.out() << _tntChunks[370]; //   <a href="/tvscraper/
#line 1083 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[371]; // " target="_blank">\n    <img src="/tvscraper/
#line 1084 "pageelems.ecpp"
  reply.sout() << ( media.path );
  reply.out() << _tntChunks[372]; // " class="artwork">\n    </img>\n  </a>\n
#line 1087 "pageelems.ecpp"

}

  // <%/cpp>
  return DEFAULT;
}

unsigned _component_::about_tt_box_type::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("pageelems::about_tt_box " << qparam.getUrl());
  tnt::DataChunks _tntChunks(rawData);
#line 51 "pageelems.ecpp"
  typedef int update_status_type;
  TNT_SESSION_SHARED_VAR(int, update_status, (1));   // <%session> int update_status(1)
  _tnt_ignore_unused<update_status_type>(update_status);
  // <%cpp>
  reply.out() << _tntChunks[374]; // \t<div class="epg_description" id="aboutBox">\n\t\t<div class="station">\n\t\t\t<div class="boxheader"><div><div class="caption">
#line 1096 "pageelems.ecpp"
  reply.sout() << ( tr(LIVESUMMARY) );
  reply.out() << _tntChunks[375]; // </div></div></div>\n\t\t</div>\n\t\t<div class="epg_content">\n\t\t\t<div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1100 "pageelems.ecpp"
  reply.sout() << ( tr("Authors") );
  reply.out() << _tntChunks[376]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 1101 "pageelems.ecpp"
  reply.sout() << ( tr("Project Idea") );
  reply.out() << _tntChunks[377]; // :</div>\n\t\t\t\t<div class="about_right">Thomas Keil (Thomas)</div>\n\t\t\t\t<div class="about_left">
#line 1103 "pageelems.ecpp"
  reply.sout() << ( tr("Webserver") );
  reply.out() << _tntChunks[378]; // :</div>\n\t\t\t\t<div class="about_right">Sascha Volkenandt (LordJaxom)</div>\n\t\t\t\t<div class="about_left">
#line 1105 "pageelems.ecpp"
  reply.sout() << ( tr("Current Maintainer") );
  reply.out() << _tntChunks[379]; // :</div>\n\t\t\t\t<div class="about_right">Markus Ehrnsperger (MarkusE @ <a href="https://www.vdr-portal.de">VDR Portal</a>)</div>\n\t\t\t\t<div class="about_left">
#line 1107 "pageelems.ecpp"
  reply.sout() << ( tr("Previous Maintainer") );
  reply.out() << _tntChunks[380]; // :</div>\n\t\t\t\t<div class="about_right">Jasmin Jessich (jasminj)</div>\n\t\t\t\t<div class="about_left">
#line 1109 "pageelems.ecpp"
  reply.sout() << ( tr("Project leader") );
  reply.out() << _tntChunks[381]; // :</div>\n\t\t\t\t<div class="about_right">Dieter Hametner (tadi)</div>\n\t\t\t\t<div class="about_left">
#line 1111 "pageelems.ecpp"
  reply.sout() << ( tr("Content") );
  reply.out() << _tntChunks[382]; // :</div>\n\t\t\t\t<div class="about_right">Christian Wieninger (winni)</div>\n\t\t\t\t<div class="about_left">
#line 1113 "pageelems.ecpp"
  reply.sout() << ( tr("Graphics") );
  reply.out() << _tntChunks[383]; // :</div>\n\t\t\t\t<div class="about_right">Michael Br&uuml;ckner (skiller2k1)</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1115 "pageelems.ecpp"
  reply.sout() << ( tr("Information") );
  reply.out() << _tntChunks[384]; // </div></div></div>\n\t\t\t\t<div class="about_left">
#line 1116 "pageelems.ecpp"
  reply.sout() << ( tr("LIVE version") );
  reply.out() << _tntChunks[385]; // :</div>\n\t\t\t\t<div class="about_right">
#line 1117 "pageelems.ecpp"
  reply.sout() << ( LIVEVERSION );
#line 1117 "pageelems.ecpp"
  reply.sout() << ( VERSION_SUFFIX );
  reply.out() << _tntChunks[386]; // </div>\n\t\t\t\t<div class="about_left">
#line 1118 "pageelems.ecpp"
  reply.sout() << ( tr("VDR version") );
  reply.out() << _tntChunks[387]; // :</div>\n\t\t\t\t<div class="about_right">
#line 1119 "pageelems.ecpp"
  reply.sout() << ( VDRVERSION );
  reply.out() << _tntChunks[388]; // </div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1120 "pageelems.ecpp"
  reply.sout() << ( tr("Features") );
  reply.out() << _tntChunks[389]; // </div></div></div>\n\t\t\t\t<div class="about_left">EPGsearch:</div>\n\t\t\t\t<div class="about_right">\n
#line 1123 "pageelems.ecpp"
					Features< features::epgsearch >& epgsearch = LiveFeatures< features::epgsearch >();

  reply.out() << _tntChunks[390]; // \t\t\t\t\t<img align="center" src="
#line 1124 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", epgsearch.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[391]; // "/>\n
#line 1125 "pageelems.ecpp"
					if ( epgsearch.Recent() ) {

  reply.out() << _tntChunks[392]; // \t\t\t\t\t\t
#line 1126 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[393]; // : 
#line 1126 "pageelems.ecpp"
  reply.sout() << ( epgsearch.Version() );
  reply.out() << _tntChunks[394]; // \n
#line 1127 "pageelems.ecpp"
					} else {

  reply.out() << _tntChunks[395]; // \t\t\t\t\t\t
#line 1128 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[396]; // : 
#line 1128 "pageelems.ecpp"
  reply.sout() << ( epgsearch.MinVersion() );
  reply.out() << _tntChunks[397]; // \n
#line 1129 "pageelems.ecpp"
					}

  reply.out() << _tntChunks[398]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-epgsearch" target="_blank">
#line 1130 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[399]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">Streamdev server:</div>\n\t\t\t\t<div class="about_right">\n
#line 1134 "pageelems.ecpp"

					Features< features::streamdev_server >& streamdev = LiveFeatures< features::streamdev_server >();

  reply.out() << _tntChunks[400]; // \t\t\t\t\t<img align="center" src="
#line 1137 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", streamdev.Loaded() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[401]; // "/>\n
#line 1138 "pageelems.ecpp"

					if ( streamdev.Loaded() ) {

  reply.out() << _tntChunks[402]; // \t\t\t\t\t\t
#line 1141 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[403]; // : 
#line 1141 "pageelems.ecpp"
  reply.sout() << ( streamdev.Version() );
  reply.out() << _tntChunks[404]; // \n
#line 1142 "pageelems.ecpp"

					} else {

  reply.out() << _tntChunks[405]; // \t\t\t\t\t\t
#line 1145 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[406]; // : 
#line 1145 "pageelems.ecpp"
  reply.sout() << ( streamdev.MinVersion() );
  reply.out() << _tntChunks[407]; // \n
#line 1146 "pageelems.ecpp"

					}

  reply.out() << _tntChunks[408]; // \t\t\t\t\t(<a href="https://github.com/vdr-projects/vdr-plugin-streamdev" target="_blank">
#line 1149 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[409]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_left">tvscraper:</div>\n\t\t\t\t<div class="about_right">\n
#line 1153 "pageelems.ecpp"
					Features< features::tvscraper >& tvscraper = LiveFeatures< features::tvscraper >();

  reply.out() << _tntChunks[410]; // \t\t\t\t\t<img align="center" src="
#line 1154 "pageelems.ecpp"
  reply.sout() << ( LiveSetup().GetThemedLink("img", tvscraper.Recent() ? "active.png" : "inactive.png") );
  reply.out() << _tntChunks[411]; // "/>\n
#line 1155 "pageelems.ecpp"
					if ( tvscraper.Recent() ) {

  reply.out() << _tntChunks[412]; // \t\t\t\t\t\t
#line 1156 "pageelems.ecpp"
  reply.sout() << ( tr("active") );
  reply.out() << _tntChunks[413]; // : 
#line 1156 "pageelems.ecpp"
  reply.sout() << ( tvscraper.Version() );
  reply.out() << _tntChunks[414]; // \n
#line 1157 "pageelems.ecpp"
					} else {

  reply.out() << _tntChunks[415]; // \t\t\t\t\t\t
#line 1158 "pageelems.ecpp"
  reply.sout() << ( tr("required") );
  reply.out() << _tntChunks[416]; // : 
#line 1158 "pageelems.ecpp"
  reply.sout() << ( tvscraper.MinVersion() );
  reply.out() << _tntChunks[417]; // \n
#line 1159 "pageelems.ecpp"
					}

  reply.out() << _tntChunks[418]; // \t\t\t\t\t(<a href="https://github.com/MarkusEh/vdr-plugin-tvscraper" target="_blank">
#line 1160 "pageelems.ecpp"
  reply.sout() << ( tr("Homepage") );
  reply.out() << _tntChunks[419]; // </a>)<br/>\n\t\t\t\t</div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1162 "pageelems.ecpp"
  reply.sout() << ( tr("Information providers") );
  reply.out() << _tntChunks[420]; // </div></div></div>\n\t\t\t\t<div class="about_line">Movie information provided by <a target="_blank" href="https://www.themoviedb.org/">TMDB</a>. This product uses the TMDB API but is not endorsed or certified by TMDB</div>\n\t\t\t\t<div class="about_line">Information provided by TheTVDB.com. Please consider <a target="_blank" href="https://u10505776.ct.sendgrid.net/ls/click\?upn=xMYYCP13hVd-2BZPpbVcMPHeLXfv-2BPRdIsKm2qSeirIHi7kH9am8IxD-2BavFbeqGqIXIcjH_INgc0CXRkIvGU-2BJ1W6HLAynNbR0UBoMb2tkpDdezO3QRj-2FQPQAMrtJKVcB0N7eSvbYpjQTDNOQBf2pb94uDgGr0-2BXyXFk7Oyfva30BASYCRLvtRQyi5eOCAbH8fon7UETlPydobeLA3Recu9OsXol8c7Ng4pDAsH6KsFF8CH7HQoVxivnpKrQW2v4ek7U-2BYlWmH31o9Koke3vq-2FDsQ0P-2BiKLECU3LgttsntUcN8fnUs-3D">supporting them</a></div>\n\t\t\t\t<div class="about_head"><div><div>
#line 1165 "pageelems.ecpp"
  reply.sout() << ( tr("Bugs and suggestions") );
  reply.out() << _tntChunks[421]; // </div></div></div>\n\t\t\t\t<div class="about_line">
#line 1166 "pageelems.ecpp"
  reply.sout() << ( tr("If you encounter any bugs or would like to suggest new features, please use our bugtracker") );
  reply.out() << _tntChunks[422]; // :<br/>\n\t\t\t\t\t<a target="_blank" href="https://github.com/MarkusEh/vdr-plugin-live/issues">https://github.com/MarkusEh/vdr-plugin-live/issues</a></div>\n\t\t\t\t<div class="about_head"><div><div>&nbsp;</div></div></div>\n\t\t\t</div>\n\t\t</div>\n\t</div>\n
  // <%/cpp>
  return DEFAULT;
}

} // namespace
