////////////////////////////////////////////////////////////////////////
// switch_channel.cpp
// generated with ecppc
//

#include <tnt/ecpp.h>
#include <tnt/httprequest.h>
#include <tnt/httpreply.h>
#include <tnt/httpheader.h>
#include <tnt/http.h>
#include <tnt/data.h>
#include <tnt/componentfactory.h>
#include <cxxtools/log.h>
#include <stdexcept>

log_define("component.switch_channel")

// <%pre>
#line 1 "switch_channel.ecpp"


#include <exception.h>
#include <tasks.h>
#include <tools.h>
#include <users.h>

using namespace vdrlive;


// </%pre>

namespace
{
class _component_ : public tnt::EcppComponent
{
    _component_& main()  { return *this; }

  protected:
    ~_component_();

  public:
    _component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl);

    unsigned operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam);
};

static tnt::EcppComponentFactoryImpl<_component_> Factory("switch_channel");

static const char* rawData = "\030\000\000\0005\000\000\000C\000\000\000P\000\000\000c\000\000\000d\000\000\000Normale "
  "Seite:<br/>\nchannel: <br/>\nresult: <br/>\nerror: <br />\nSeitenende!\n\n";

// <%shared>
// </%shared>

// <%config>
// </%config>

_component_::_component_(const tnt::Compident& ci, const tnt::Urlmapper& um, tnt::Comploader& cl)
  : EcppComponent(ci, um, cl)
{
  // <%init>
  // </%init>
}

_component_::~_component_()
{
  // <%cleanup>
  // </%cleanup>
}

template <typename T>
inline void _tnt_ignore_unused(const T&) { }

unsigned _component_::operator() (tnt::HttpRequest& request, tnt::HttpReply& reply, tnt::QueryParams& qparam)
{
  log_trace("switch_channel " << qparam.getUrl());

  tnt::DataChunks _tntChunks(rawData);

  // <%args>
std::string param = qparam.get< std::string >("param");
std::string async = qparam.get< std::string >("async");
  // </%args>

  // <%cpp>
#line 15 "switch_channel.ecpp"

	tChannelID paramID;
        paramID = paramID.FromString(param.c_str());
	bool ajaxReq = !async.empty() && (lexical_cast<int>(async) != 0);
	std::string referrer;

	if (!cUser::CurrentUserHasRightTo(UR_SWITCHCHNL))
		throw HtmlError( tr("Sorry, no permission. Please contact your administrator!") );

	if (ajaxReq) {
		reply.setContentType( "application/xml" );
	}
	else {
		referrer = request.getHeader("Referer:");
	}

	SwitchChannelTask task( paramID );
	LiveTaskManager().Execute( task );

	if (!ajaxReq) {
		if (!referrer.empty()) {
			return reply.redirect(referrer);
		}

  reply.out() << _tntChunks[0]; // Normale Seite:<br/>\nchannel: 
#line 40 "switch_channel.ecpp"
  reply.sout() << ( paramID );
  reply.out() << _tntChunks[1]; // <br/>\nresult: 
#line 41 "switch_channel.ecpp"
  reply.sout() << ( (task.Result()) );
  reply.out() << _tntChunks[2]; // <br/>\nerror: 
#line 42 "switch_channel.ecpp"
  reply.sout() << ( (task.Error()) );
  reply.out() << _tntChunks[3]; // <br />\nSeitenende!\n
#line 44 "switch_channel.ecpp"

	}
	else {

  // <& xmlresponse.ajax ...
  { 
#line 48 "switch_channel.ecpp"
    tnt::QueryParams _tnt_cq0;
#line 48 "switch_channel.ecpp"
    _tnt_cq0.add( "error", (task.Error()));
#line 48 "switch_channel.ecpp"
    _tnt_cq0.add( "name", ("switch_channel"));
#line 48 "switch_channel.ecpp"
    _tnt_cq0.add( "pname", ("channel"));
#line 48 "switch_channel.ecpp"
    _tnt_cq0.add( "result", (task.Result()));
#line 48 "switch_channel.ecpp"
    _tnt_cq0.add( "value", (paramID));
#line 48 "switch_channel.ecpp"
    callComp(tnt::Subcompident(std::string(), "xmlresponse", "ajax"), request, reply, _tnt_cq0);
    // &>
  }
  reply.out() << _tntChunks[4]; // \n
#line 49 "switch_channel.ecpp"

	}

  // <%/cpp>
  return DEFAULT;
}

} // namespace
